
# -------------------------------------------
# Set the CMAKE PARAMETERS
#  -------------------------------------------
MACRO(SET_CMAKE_PARAMETERS)
  SET(CMAKE_VERBOSE_MAKEFILE ON) # OFF
  SET(CMAKE_COLOR_MAKEFILE ON)   # to add Color on CMake Process 
ENDMACRO(SET_CMAKE_PARAMETERS)


#SET(DEBUG_MODE TRUE)

# --------------------------------------------------------------------------------
# General info first line
# --------------------------------------------------------------------------------
MACRO(MESSAGE_HEADER_LINE)
  MESSAGE("\n##--- POLYCHRONY INFO ---##--- POLYCHRONY INFO ---##--- POLYCHRONY INFO ---##---")
ENDMACRO(MESSAGE_HEADER_LINE)

# --------------------------------------------------------------------------------
# General info command line
# --------------------------------------------------------------------------------
MACRO(MESSAGE_PARAGRAPH_LINE CMD_STRING)
  MESSAGE("=> " ${CMD_STRING})
ENDMACRO(MESSAGE_PARAGRAPH_LINE)

# --------------------------------------------------------------------------------
# General info command line
# --------------------------------------------------------------------------------
MACRO(MESSAGE_SUB_LINE CMD_STRING)
  MESSAGE("   " ${CMD_STRING})
ENDMACRO(MESSAGE_SUB_LINE)

# --------------------------------------------------------------------------------
# General info last line
# --------------------------------------------------------------------------------
MACRO(GEN_MESSAGE_END)
  MESSAGE("# ------------------# ------------------# ------------------# ---------------- #")
ENDMACRO(GEN_MESSAGE_END)

# --------------------------------------------------------------------------------
# General info command line
# --------------------------------------------------------------------------------
MACRO(MESSAGE_COMMAND_LINE CMD_STRING)
  MESSAGE(${CMD_STRING})
ENDMACRO(MESSAGE_COMMAND_LINE)

# -------------------------------------------
# It prints arg in DEBUG MODE
# -------------------------------------------
MACRO(PRINT arg)
  IF(DEBUG_MODE)
    MESSAGE(${arg})
  ENDIF(DEBUG_MODE)
ENDMACRO(PRINT arg)
