
#define TRUE 1
#define FALSE 0

#define __BTRACE__ 0

void
putlabel (Widget w, char *c)
/************* Change the widget label */
{
  XmString str;
  Arg al[1];
  int ac = 0;

  str = XmStringCreateLtoR (c, XmSTRING_DEFAULT_CHARSET);
  (void) XtSetArg (al[ac], XmNlabelString, str);
  ac++;
  (void) XtSetValues (w, al, ac);
  (void) XmStringFree (str);
}

/*================
  MONITORING PANEL
  ================*/

struct rhythm_descr
{
  /*     ------------ */
  Widget discount;
  GC dgc;
  int dgchi, dgcwi, x, y;
  int vupdown;
  int vcode;
};

void
make_display_scale (struct rhythm_descr *scale_pt, int X, int Y)
/*******************************  Initialization procedure */
{
  Widget mys_widget;
  XGCValues values;

  mys_widget = (*scale_pt).discount;
  values.font = XLoadFont (XtDisplay (mys_widget), "6x10");
  XtVaGetValues (mys_widget, XmNforeground, &values.foreground, XmNbackground, &values.background, NULL);
  (*scale_pt).dgc = XtGetGC (mys_widget, GCForeground | GCBackground | GCFont, &values);
  (*scale_pt).dgchi = 10;
  (*scale_pt).dgcwi = 6;
  (*scale_pt).x = X;
  (*scale_pt).y = Y;
  (*scale_pt).vcode = NUL_CODE;
}

int
RUPDOWN (struct rhythm_descr *widgst_pt)
/********************** Called by the SIGNAL program to get indicator*/
{
  long int off4;

  off4 = (*widgst_pt).vupdown;
  return (off4);
}

int
RCHANGE (struct rhythm_descr *widgst_pt)
/********************* Called by the SIGNAL program to get event*/
{
  long int off4;

  off4 = (*widgst_pt).vcode;
  (*widgst_pt).vcode = NUL_CODE;
  return (off4);
}

void
wnbwrite (struct rhythm_descr *widgst_pt, char str_v[10])
/************************ */
{
  Display *ecran;
  Window fenetre;
  int height;
  int x1, y1;

  x1 = (*widgst_pt).x;
  y1 = (*widgst_pt).y;
  ecran = XtDisplay ((*widgst_pt).discount);
  fenetre = XtWindow ((*widgst_pt).discount);
  height = (*widgst_pt).dgchi;
  XClearArea (ecran, fenetre, x1, y1 - height + 1, 10 * (*widgst_pt).dgcwi, height, FALSE);
  XDrawString (ecran, fenetre, (*widgst_pt).dgc, x1, y1, str_v, 9);
}

/*------------------ write an integer number*/
void
WIWRITE (struct rhythm_descr *widgst_pt, int v)
{
  char str_v[10];

  sprintf (str_v, "%9d", v);
  wnbwrite (widgst_pt, str_v);
}

/*------------------ write a float number */
void
wrwrite (struct rhythm_descr *widgst_pt, float v)
{
  char str_v[10];
  sprintf (str_v, "%.9f", v);
  wnbwrite (widgst_pt, str_v);
}

/*============
  DRAWING AREA
  ============*/

struct display_descr
{
  Widget ecran;
  GC dgc;
  int y0;
};

void
make_display_descr (struct display_descr *display_pt, int DY)
/********************************  Initialization procedure */
{
  Widget widget;
  XGCValues values;

  widget = (*display_pt).ecran;
  values.font = XLoadFont (XtDisplay (widget), "6x10");
  XtVaGetValues (widget, XmNforeground, &values.foreground, XmNbackground, &values.background, NULL);
  (*display_pt).dgc = XtGetGC (widget, GCForeground | GCBackground | GCFont, &values);
  (*display_pt).y0 = DY;
}

void
WVLINE (struct display_descr *widgst_pt, long int x1, long int y1, long int y2)
/************************ Draw a vertical line */
{
  XDrawLine (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), (*widgst_pt).dgc, x1, -y1 + (*widgst_pt).y0, x1, -y2 + (*widgst_pt).y0);
}

void
WHLINE (struct display_descr *widgst_pt, long int x1, long int y1, long int x2)
/************************ Draw an horizontal line */
{

  if (__BTRACE__)
    {
      printf ("whline x1 : %d", x1);
      printf ("whline x2 : %d", x2);
      printf ("whline y1 : %d", y1);
    }

  XDrawLine (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), (*widgst_pt).dgc, x1, -y1 + (*widgst_pt).y0, x2, -y1 + (*widgst_pt).y0);
}

void
WLINE (struct display_descr *widgst_pt, long int x1, long int y1, long int x2, long int y2)
/************************ Draw an line */
{
  XDrawLine (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), (*widgst_pt).dgc, x1, (*widgst_pt).y0 - y1, x2, (*widgst_pt).y0 - y2);
  if (__BTRACE__)
    {
      printf ("whine x1 : %d", x1);
      printf ("whine x1 : %d", x1);
    }
}


/*Draw the range of values corresponding to the array tab in a file */
void
WARRAY (int tab[], long int size)
{
  FILE *file_out;
  int i;
  file_out = fopen ("RELEASED_processes.out", "wt");
  if (!file_out)
    {
      fprintf (stderr, "Can not open file %s\n", "Waiting_clients.out");
      exit (1);
    };
  for (i = 0; i < size; i = i + 1)
    {
      fprintf (file_out, "%d\n", tab[i]);
    }
  fclose (file_out);
}


/*Draw the string corresponding to the integer ch at the position (x,y) */
void
WSTRING (struct display_descr *widgst_pt, long int ch, long int x, long int y)
{
  char str_v[3];
  sprintf (str_v, "%3d", ch);
  XDrawString (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), (*widgst_pt).dgc, x, (*widgst_pt).y0 - y, str_v, 3);
}



/*Draw a filled rectangle (x1,y1) left corner, may be up or down corner */
void
WRECT (struct display_descr *widgst_pt, long int x1, long int y1, long int x2, long int y2)
/************************ Draw a filled rectangle */
{
  int larg, haut, y;

  larg = abs (x2 - x1);
  haut = abs (y2 - y1);
  if (y1 < y2)
    y = y2;
  else
    y = y1;
  if (haut != 0)
    /* for FillRectangle, the corner (x,y) must be the left, upper corner */
    XFillRectangle (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), (*widgst_pt).dgc, x1, (*widgst_pt).y0 - y, larg, haut);
  else
    XDrawLine (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), (*widgst_pt).dgc, x1, -y1 + (*widgst_pt).y0, x2, -y1 + (*widgst_pt).y0);

}

void
WEFFACE (struct display_descr *widgst_pt, long int x1, long int dx, long int dy)
/**************************** Clear a rectangular array */
{
  XClearArea (XtDisplay ((*widgst_pt).ecran), XtWindow ((*widgst_pt).ecran), x1, (*widgst_pt).y0 - dy, dx, 2 * dy, FALSE);
}

int
realtoint (float v)
/*********** Type conversion */
{
  return ((int) v);
}

float
inttoreal (int v)
/*********** Type conversion */
{
  return ((float) v);
}
