/***************************************
*    Procedures graphiques exportees   *
***************************************/

/**********************************************************************/
/**	fonction RECTANGLE()				             **/
/**							             **/
/**	Cette fonction dessine les feux clignotants (fen=1) ou	     **/
/**	les voyants du panneau de controle               	     **/
/**********************************************************************/


extern void RECTANGLE(int fen, int x1,int y1,int x2,int y2,int couleur)
{
  int x,y,w,h;
  Pixel coul;

  if (fen==1)      
    {
      x = x1;
      y = y1;
      w = x2 - x + 1;
      h = y2 - y +1;
      
      XClearArea(XtDisplay(canvas.w),XtWindow(canvas.w),x,y,w,h,FALSE);

      if (couleur==0) 
	XFillRectangle(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,x,y,w,h);
      else
	XDrawRectangle(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,x,y,w,h);
    }
  else
    {
      if (couleur == 1) coul = xcolor; else coul = (Pixel)couleur;

      if (x1== 120 && y1== 60)   XtVaSetValues(sOV1,XtNbackground, coul,NULL);
      else      if (x1== 240 && y1== 60)   XtVaSetValues(sCV1,XtNbackground,coul,NULL);
      else      if (x1== 360 && y1== 60)   XtVaSetValues(sEV1,XtNbackground,coul,NULL);
      else      if (x1== 120 && y1== 100)  XtVaSetValues(sOV2,XtNbackground,coul,NULL);  
      else       if (x1== 240 && y1== 100)  XtVaSetValues(sCV2,XtNbackground,coul,NULL);
      else      if (x1== 360 && y1== 100)  XtVaSetValues(sEV2,XtNbackground,coul,NULL);
      else      if (x1== 137 && y1== 200)  XtVaSetValues(gPosB1,XtNbackground,coul,NULL);
      else      if (x1== 280 && y1== 200)  XtVaSetValues(gPanMB1,XtNbackground,coul,NULL);
      else      if (x1== 400 && y1== 200)  XtVaSetValues(gPanDB1,XtNbackground,coul,NULL);
      else      if (x1== 137 && y1== 240)  XtVaSetValues(gPosB2,XtNbackground,coul,NULL);
      else      if (x1== 280 && y1== 240)  XtVaSetValues(gPanMB2,XtNbackground,coul,NULL);
      else      if (x1== 400 && y1== 240)  XtVaSetValues(gPanDB2,XtNbackground,coul,NULL);
    }
}

							             							

/**********************************************************************/
/**	fonction affentier()				             **/
/**							             **/
/**	Cette fonction affiche le decompte relatif a chaque voie     **/
/**						              	     **/
/**********************************************************************/

extern void AFFENTIER(int n,int x1, int y1)
{
  sprintf(chaine,"%3ld",n);
  XClearArea(XtDisplay(canvas.w),XtWindow(canvas.w),x1,y1-10,20,10,FALSE);
  XDrawString(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,
	      x1,y1,chaine,strlen(chaine));
}


/**********************************************************************/
/**	fonctions efface_barriere(),trace_barriere		     **/
/**							             **/
/**	Ces fonctions  sont utilisees pour representer le mouvement  **/
/**	de la barriere             	  		             **/
/**********************************************************************/


extern boolean EFFACE_BARRIERE(int x,int y,int p)
{
  int a,b,c,d;

  a = x;
  b = y;
  c = a + tabpos[p];
  d = b - tabpos[9-p];

  XClearArea(XtDisplay(canvas.w),XtWindow(canvas.w),a,b-60,61,61,FALSE);
  return TRUE;
}


extern void TRACE_BARRIERE(int x,int y,int p, boolean efface)
{
  int a,b,c,d;

  a = x;
  b = y;
  c = a + tabpos[p];
  d = b - tabpos[9-p];

  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, a,b,c,d);
}


/**********************************************************************/
/**	fonction dessinertrain()				     **/
/**							             **/
/**	Cette fonction  est utilisee pour representer le mouvement   **/
/**	du train            	  			             **/
/**********************************************************************/

extern void DESSINERTRAIN(float xdeb,float xfin,float l,int y1,int y2,int zx1,int zx2,
			  int zx3,int s,int *x1,int *x2,int *x3)
{
  int a,b,c;
  int x,y,z,yy,w,h;
  float xw,xmin;

  c = project((xdeb + xfin)/2,s);
  a = project(xdeb,s);
  b = project(xfin,s);

  /* Resultat */

  *x3 = c;
  *x1 = a;
  *x2 = b;
  if (a != zx1 || b != zx2 || c != zx3)
    {

      /* Effacement du train precedent */
      if (s > 0)
	{ x = zx2; w = zx1 - x + 1;}
      else
	{ x = zx1; w = zx2 - x + 1;}
      y = y2; yy = y1; h = yy - y + 1;
      XClearArea(XtDisplay(canvas.w),XtWindow(canvas.w),x,y,w,h,FALSE); 

      /* Affichage du nouveau train */

      XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, a,yy,b,yy);

      z = yy - ht(a);
      XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, a,yy,a,z);
		
      xmin = xfin;

      for (xw = xdeb - l; (xw > xmin); xw -= l)
	{
	  x = project(xw,s);
	  if (x != a)
	    {
	      y = yy - ht(x);
	      XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, x,y,a,z);
	      XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, x,y,x,yy);
	      z = y;
	      a = x;
	    }
	}

      y = yy - ht(b);
      XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, b,y,a,z);
      XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg, b,y,b,yy);		       
	
    }
}

extern void RAZSLIDER(int n)
{
  XtVaSetValues(slider[n],XtNvalue,0,NULL);
}

extern void ALERTE(boolean h)
{
  b_alert = true;
}

/***************************************************************************************/
/**	 Ces fonctions lisent les variables associees aux entrees du programme SIGNAL **/
/***************************************************************************************/
extern boolean r_TRAIN_HV11(boolean *b)
{
  *b = hgV1V1;
  hgV1V1 = false;
  return true;
}

extern boolean r_TRAIN_V11(float *v)
{   int x;

 XtVaGetValues(gV1V1,XtNvalue,&x,NULL);
 *v = (float) ( x / 360.);
 return true;
}



extern boolean r_TRAIN_HV12(boolean *b)
{
  *b = hgV1V2;
  hgV1V2 = false;
  return true;
}

extern boolean r_TRAIN_V12(float *v)
{   int x;
 XtVaGetValues(gV1V2,XtNvalue,&x,NULL);
 *v = (float)( x / 360.);
 return true;
}

extern boolean r_TRAIN_HV21(boolean *b)
{
  *b = hgV2V1;
  hgV2V1= false;
  return true;
}

extern boolean r_TRAIN_V21(float *v)
{ 
  int x;

  XtVaGetValues(gV2V1,XtNvalue,&x,NULL);
  *v = (float)( x / 360. );
  return true;
}


extern boolean r_TRAIN_HV22(boolean *b)
{
  *b = hgV2V2;
  hgV2V2 = false;
  return true;
}

extern boolean r_TRAIN_V22(float *v)
{   int x;

 XtVaGetValues(gV2V2,XtNvalue,&x,NULL);
 *v = (float)( x / 360. );
 return true;
}


extern boolean r_TRAIN_HLW1(boolean *b)
{
  *b = hgLV1;
  hgLV1 = false;
  return true;
}


extern boolean r_TRAIN_LW1(float *l)
{   int x;

 XtVaGetValues(gLV1,XtNvalue,&x,NULL);
 *l = (float) x;
 return true;
}


extern boolean r_TRAIN_HLW2(boolean *b)
{
  *b = hgLV2;
  hgLV2 = false;
  return true;
}


extern boolean r_TRAIN_LW2(float *l)
{   int x;

 XtVaGetValues(gLV2,XtNvalue,&x,NULL);
 *l = (float) x;   
 return true;
}


extern boolean r_TRAIN_HNW1(boolean *b)
{
  *b = hgNV1;
  hgNV1 = false;
  return true;
}


extern boolean r_TRAIN_NW1(int *n)
{
  XtVaGetValues(gNV1,XtNvalue,&n,NULL);
  return true;
}


extern  boolean r_TRAIN_HNW2(boolean *b)
{
  *b = hgNV2;
  hgNV2 = false;
  return true;
}

extern boolean r_TRAIN_NW2(int *n)
{
  XtVaGetValues(gNV2,XtNvalue,&n,NULL);
  return true;
}



extern boolean r_TRAIN_HREPARER1(boolean *b)
{
  *b = hrB1;
  hrB1 = false;
  return true;
}


extern boolean r_TRAIN_HPANNE1(boolean *b)
{
  *b = hpB1;
  hpB1 = false;
  return true;
}


extern boolean r_TRAIN_HDEFAILLANCE1(boolean *b)
{
  *b = hdB1;
  hdB1 = false;
  return true;
}


extern boolean r_TRAIN_HREPARER2(boolean *b)
{
  *b = hrB2;
  hrB2 = false;
  return true;
}


extern boolean r_TRAIN_HPANNE2(boolean *b)
{
  *b = hpB2;
  hpB2 = false;
  return true;
}


extern boolean r_TRAIN_HDEFAILLANCE2(boolean *b)
{
  *b = hdB2;
  hdB2 = false;
  return true;
}


extern boolean r_TRAIN_H(boolean *b)
{
  *b = true;
  return true;
}
