
static Widget creer_label(char *nom, Widget pere)
{
  return(XtVaCreateManagedWidget(nom, xmLabelWidgetClass, pere,
				 XmNlabelString, XmStringCreateLtoR(nom, 
								    XmSTRING_DEFAULT_CHARSET), 
				 XmNwidth, LABEL_WIDTH, XmNheight, BUTTON_HEIGHT, NULL));
}


static Widget creer_bouton(char *nom, Widget pere)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, XmNwidth, BUTTON_WIDTH,
				 XmNborderWidth, 2, XmNlabelString, 
				XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
				 NULL));
}

static Widget creer_jauge(char *nom, Widget pere, int min, int max)
{
  return(XtVaCreateManagedWidget(nom, xmScaleWidgetClass, pere, XmNtitleString, 
				 XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
				 XmNminimum, min, XmNmaximum, max, XmNshowValue, true, 
				 XmNorientation, XmHORIZONTAL, XmNscaleHeight, 30, NULL));
}


static void creation_pace_rhythm(Widget w)
{
  Widget     t_widg, widg1, widg2, widg3, widg4, canvas_widg;

  canvas_widg = XtVaCreateManagedWidget("meter_pace", xmDrawingAreaWidgetClass, w, 
					XmNborderWidth, 0, XmNwidth, 180, XmNheight, 25 /*45 */, 
					XmNtopAttachment, XmATTACH_FORM, 
					XmNbottomAttachment, XmATTACH_FORM, NULL);
  meter_pace_creat(canvas_widg);
  widg1 = creer_bouton("+", w);
  XtVaSetValues(widg1,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, canvas_widg, NULL);
  XtAddCallback(widg1, XmNactivateCallback, inter_pace_up_p, NULL);
  widg2 = creer_bouton("-", w);
  XtAddCallback(widg2, XmNactivateCallback, inter_auto, NULL);
  XtVaSetValues(widg2,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		  XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg1, NULL);
  XtAddCallback(widg2, XmNactivateCallback, inter_pace_down_p, NULL);
  widg3 = creer_bouton("/", w);
  XtVaSetValues(widg3,  XmNheight, BUTTON_HEIGHT_PACE , XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg2 , NULL);
  XtAddCallback(widg3, XmNactivateCallback,  inter_pace_down_m, NULL);
  widg4 = creer_bouton("*", w);
  XtVaSetValues(widg4,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg3 , NULL);
  XtAddCallback(widg4, XmNactivateCallback,  inter_pace_up_m, NULL);
}


static void creation_pace_control(Widget w)
{
  Widget     t_widg, widg;

  t_widg = creer_bouton("TICK", w);
  XtVaSetValues(t_widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(t_widg, XmNactivateCallback, inter_tick, NULL);
  widg = creer_bouton("AUTO", w);
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_WIDGET, XmNrightWidget, t_widg, NULL);
  XtAddCallback(widg, XmNactivateCallback, inter_auto, NULL);
  auto_creat(widg);
  widg = creer_bouton("QUIT", w);
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(widg, XmNactivateCallback, inter_stop, NULL);
  stop_creat(widg);
}



static void creation_pace_maker(Widget w)
{
  Widget  control_widg, rhythm_widg;

  rhythm_widg = XtVaCreateManagedWidget("pace_rhythm", xmFormWidgetClass, w, 
					XmNborderWidth, 1,
					XmNtopAttachment, XmATTACH_FORM, 
					XmNrightAttachment, XmATTACH_FORM,
					XmNleftAttachment, XmATTACH_FORM,
					NULL);
  creation_pace_rhythm(rhythm_widg);
  control_widg = XtVaCreateManagedWidget("pace_control", xmFormWidgetClass, w, 
					 XmNrightAttachment, XmATTACH_FORM,
					 XmNleftAttachment, XmATTACH_FORM,
					 XmNtopAttachment, XmATTACH_WIDGET,
					 XmNtopWidget, rhythm_widg,
					 NULL);
  creation_pace_control(control_widg);
}

#define  MIN_A 0
#define  MAX_A 60

static void creation_panel_scale(Widget w)
{
  Widget   w1, w2;

  w1 = creer_jauge("A          ", w, MIN_A, MAX_A);
  XtVaSetValues(w1, XmNtopAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(w1, XmNdragCallback, (XtCallbackProc)inter_A, NULL);
}

static void creation_panel_gauche(Widget w)
{
  Widget    w1, w2;

  w1 = creer_label("clock(X)", w);
  XtVaSetValues(w, XmNtopAttachment, XmATTACH_FORM, NULL);
  w2 = creer_label("X := A", w);
  //  XtVaSetValues(w2, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w1, NULL);
  XtVaSetValues(w2, XmNbottomAttachment, XmATTACH_FORM, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w1, NULL);
}

static void creation_id(Widget w)
{
  Widget panel_scale_widg, panel_gauche_widg, widg;

  panel_gauche_widg = XtVaCreateManagedWidget("panel_gauche", xmFormWidgetClass, w, 
					      XmNtopAttachment, XmATTACH_FORM, 
					      XmNverticalSpacing, ESP_HEIGHT, NULL);
  creation_panel_gauche(panel_gauche_widg);
  widg = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, w, 
					XmNborderWidth, 1, XmNwidth, CANVAS_WIDTH, 
					XmNheight, CANVAS_HEIGHT, XmNtopAttachment, XmATTACH_FORM,
					XmNleftAttachment, XmATTACH_WIDGET, 
					XmNleftWidget, panel_gauche_widg, NULL);
  /*  XtVaSetValues(widg,  XmNheight, CANVAS_HEIGHT, NULL);*/
  canvas_creat(widg);
  panel_scale_widg = XtVaCreateManagedWidget("panel_scale", xmFormWidgetClass, w, 
					     XmNborderWidth, 1, XmNhorizontalSpacing, 50,
					     XmNverticalSpacing, 10,
					     XmNleftAttachment,  XmATTACH_FORM,
					     XmNtopAttachment, XmATTACH_WIDGET,
					     XmNtopWidget, widg, NULL);
  creation_panel_scale(panel_scale_widg);
}

// #define NAMEAPPLI "id"

/*------------------------------------------------------------------------------
     Creation de la fenetre principale :Pace maker + clim
 ------------------------------------------------------------------------------*/
static void creation_fenetre_principale(Widget toplevel)
{
  Widget pace_maker_widg, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, NULL);
  appli_widg = XtVaCreateManagedWidget(PROGNAME, xmFormWidgetClass, frame_widg, 
				      XmNtopAttachment,  XmATTACH_FORM, 
				      XmNleftAttachment, XmATTACH_FORM, 
				      XmNrightAttachment, XmATTACH_FORM, NULL);
  //  creation_clim(appli_widg);
  creation_id(appli_widg);

  pace_maker_widg = XtVaCreateManagedWidget("pace_maker", xmFormWidgetClass, frame_widg, 
					    XmNleftAttachment, XmATTACH_FORM, 
					    XmNtopAttachment, XmATTACH_WIDGET, 
					    XmNtopWidget, appli_widg, 
					    XmNbottomAttachment, XmATTACH_FORM, NULL);
  creation_pace_maker(pace_maker_widg);
}
