process VTSEGMENT =
     { integer KMIN, LIMITEBAK, MAXTAB; }
     ( ? real PAROLE, H;
         event CSYNC;
         boolean UP, DOWN;
       ! integer NUMF, NUM;
     )
   pragmas 
      COMMENT " A voice recognition system gets in input a"
              " voice signal and restitutes the message that "
              " has been pronounced."
   end pragmas
   (| (| (| SONDENUMF(NUMF)
          | SONDENUM(NUM)
          | SONDEPAROLE(PAROLE)
          |)
       | (| HE := CSYNC
          | PACE_MAKER{}
          |) where event HE; end
       | (| CSYNC := HES
          | MODULE_SEGMENTATION{KMIN,LIMITEBAK,MAXTAB}
          |) where event CSYNC; end/ VOIS
       |)/ HES |)
   where 
   process SONDEPAROLE =
        ( ? real PAROLE;
        )
   
   ; 
   process PACE_MAKER =
        ( ? event HE;
            boolean UP, DOWN;
          ! event HES;
        )
      (| (| (| (| (| (| ZV := V_BOUND$1 init 1
                      | V1 := ZV when UP when (ZV>1)
                      | V2 := ZV when DOWN
                      | VU := V1/2
                      | VD := V2+V2
                      | V_BOUND := VU default VD default ZV
                      |)
                   | V_BOUND_1 := V_BOUND
                   |)/ ZV, VD, VU, V2, V1 |) where integer V_BOUND; end
             | (| V_BOUND := V_BOUND_1
                | UP ^= DOWN ^= V_BOUND
                |) where integer V_BOUND; end
             |)
          | (| V_BOUND := V_BOUND_1
             | (| V_BOUND ^= HE
                | V := ACCU_BOUND{0}(V_BOUND,HE)
                | HES := when (V=0)
                |)
             |) where integer V_BOUND; end/ V
          |)/ V_BOUND_1 |)
      where 
      process ACCU_BOUND =
           { integer V_INIT; }
           ( ? integer V_BOUND;
               event HE;
             ! integer V;
           )
         pragmas 
            COMMENT " It is a modulo counter, the value "
                    " modulo(V_BOUND) is a signal."
         end pragmas
         (| V ^= HE
          | ZV := V$1
          | V0 := 0 when (V1>=V_BOUND)
          | V1 := ZV+1
          | V := V0 default V1
          |)
         where 
         integer V0, V1, ZV init V_INIT;
         end
      ; 
      integer V1, V2, VU, VD, ZV init 1, V_BOUND_1, V_BOUND, V;
      end
   ; 
   process SONDENUM =
        ( ? integer NUM;
        )
   
   ; 
   process SONDENUMF =
        ( ? integer NUMF;
        )
   
   ; 
   process MODULE_SEGMENTATION =
        { integer KMIN, LIMITEBAK, MAXTAB; }
        ( ? real H, PAROLE;
            event CSYNC;
          ! integer NUMF, NUM, VOIS;
        )
      (| (| (| MODULE_FILTRE{KMIN}
             | NUMF := FRONTIERE
             |) where integer FRONTIERE; end
          | (| F_HKF := F_EVENTUELLE
             | MODULE_FORWARD_BACKWARD{KMIN,LIMITEBAK,MAXTAB}
             |) where integer F_HKF; end
          |)/ F_EVENTUELLE |)
      where 
      process COMPTEUR_AFTER_RAZ =
           ( ? event CADENCE;
               boolean RAZ;
             ! integer N;
           )
         (| N ^= CADENCE default (when RAZ)
          | N := (1 when RAZ) default (ZN+1)
          | ZN := N$1
          |)
         where 
         integer ZN init 0;
         end
      ; 
      process STAT_HINKLEY =
           ( ? real VCOURT, ERRCOURT, VLONG, ERRLONG, BIAI;
               boolean SRAZ;
             ! real U;
           )
         pragmas 
            COMMENT " This process calculates the HINKLEY' s statistic"
         end pragmas
         (| RAZ := (^VCOURT) when SRAZ
          | QV := VCOURT/VLONG
          | DISTANCE := ((((2.0*ERRCOURT*ERRLONG)/VLONG)-((ERRLONG*ERRLONG*(1.0+QV))/VLONG))+(QV-1.0))/(2.0*QV)
          | ZU := U$1
          | ZZU := (0e0 when RAZ) default ZU
          | U := (ZZU+DISTANCE)-BIAI
          |)
         where 
         event RAZ;
         real QV, DISTANCE, ZU init 0e0, ZZU;
         end
      ; 
      process MODULE_FILTRE =
           { integer KMIN; }
           ( ? real H, PAROLE;
             ! integer FRONTIERE, F_EVENTUELLE;
           )
         (| (| (| Y := PAROLE
                | FILTRAGE{128}
                |) where real Y; end
             | (| Y := YFILT
                | HINKLEY_OPT{-0.8e0,80e0,KMIN}
                |) where Y; end
             | (| PAROLE := YFILT
                | SONDEFILTRE{}
                |) where PAROLE; end
             |)/ YFILT |)
         where 
         process HINKLEY_OPT =
              { real BIAIS, SEUIL;
                integer KMIN; }
              ( ? real Y;
                ! integer FRONTIERE;
                  integer F_EVENTUELLE;
              )
            (| (| (| SRAZ := RAZ_A
                   | MODELE2{4,KMIN}
                   | VCOURT_1 := VCOURT
                   | ERRCOURT_2 := ERRCOURT
                   | VLONG_3 := VLONG
                   | ERRLONG_4 := ERRLONG
                   |) where real VCOURT, ERRCOURT, VLONG, ERRLONG;
                            event SRAZ; end
                | (| COMMUT := SWITCH
                   | ERRLONG_B := ERRLONG_12
                   | VLONG_B := VLONG_11
                   | ERRCOURT_B := ERRCOURT_10
                   | VCOURT_B := VCOURT_9
                   | ERRLONG_A := ERRLONG_4
                   | VLONG_A := VLONG_3
                   | ERRCOURT_A := ERRCOURT_2
                   | VCOURT_A := VCOURT_1
                   | COMMUT_P{}
                   | VCOURT_5 := VCOURT
                   | ERRCOURT_6 := ERRCOURT
                   | VLONG_7 := VLONG
                   | ERRLONG_8 := ERRLONG
                   |) where real VCOURT_A, ERRCOURT_A, VLONG_A, ERRLONG_A, VCOURT, ERRCOURT, VLONG, ERRLONG, VCOURT_B, ERRCOURT_B, VLONG_B, ERRLONG_B;
                            event COMMUT; end
                | HY := ^Y
                | (| SRAZ := RAZ_B
                   | MODELE3{4,KMIN}
                   | VCOURT_9 := VCOURT
                   | ERRCOURT_10 := ERRCOURT
                   | VLONG_11 := VLONG
                   | ERRLONG_12 := ERRLONG
                   |) where event SRAZ;
                            real VCOURT, ERRCOURT, VLONG, ERRLONG; end
                | (| SRAZ := RAZTEST
                   | ERRLONG := ERRLONG_8
                   | VLONG := VLONG_7
                   | ERRCOURT := ERRCOURT_6
                   | VCOURT := VCOURT_5
                   | (| BIAI := BIAIS when (^VCOURT)
                      | STAT_HINKLEY{}
                      |)
                   |) where real VCOURT, ERRCOURT, VLONG, ERRLONG;
                            event SRAZ; end/ BIAI
                | (| SRAZ := RAZTEST
                   | MAX_P{}
                   |) where event SRAZ; end
                | (| MAXHKF := MAX
                   | UHKF := U
                   | (| SONDEUHKF(UHKF)
                      | SONDERAZTEST(RAZTEST)
                      | SONDEMAXHKF(MAXHKF)
                      |)
                   |) where real UHKF, MAXHKF; end
                | FRONTIERE_P{SEUIL}
                |)/ SECONDRAZ, SWITCH, RAZTEST, MAX, NOUVMAX, U, ERRLONG_12, VLONG_11, ERRCOURT_10, VCOURT_9, HY, ERRLONG_8, VLONG_7, ERRCOURT_6, VCOURT_5, RAZ_B, RAZ_A, ERRLONG_4, VLONG_3, ERRCOURT_2, VCOURT_1 |)
            where 
            boolean DETECTION, HSECONDRAZ, HU;
            integer POS_MAX;
            real BIAI, VCOURT_1, VCOURT, ERRCOURT_2, ERRCOURT, VLONG_3, VLONG, ERRLONG_4, ERRLONG, VCOURT_5, ERRCOURT_6, VLONG_7, ERRLONG_8, VCOURT_9, ERRCOURT_10, VLONG_11, ERRLONG_12, U, MAX;
            real VCOURT_A;
            real ERRCOURT_A;
            real VLONG_A;
            real ERRLONG_A;
            real VCOURT_B;
            real ERRCOURT_B;
            real VLONG_B;
            real ERRLONG_B;
            event RAZ_A, RAZ_B, HY, NOUVMAX, RAZTEST, SECONDRAZ, SWITCH;
            process COMMUT_P =
                 ( ? real VCOURT_A;
                     real ERRCOURT_A;
                     real VLONG_A;
                     real ERRLONG_A;
                     event HY;
                     event COMMUT;
                     real VCOURT_B;
                     real ERRCOURT_B;
                     real VLONG_B;
                     real ERRLONG_B;
                     event SECONDRAZ;
                   ! event RAZ_A;
                     real VCOURT;
                     real ERRCOURT;
                     real VLONG;
                     real ERRLONG;
                     event RAZ_B;
                 )
               (| (| (| COMMUT ^= BASCULE
                      | BASCULE := not ZBASCULE
                      | ZBASCULE := BASCULE$1 init true
                      | MAIN_A := (BASCULE cell HY init true) when HY
                      |)/ ZBASCULE, BASCULE
                   | (| VCOURT := (VCOURT_A when MAIN_A) default (VCOURT_B when (not MAIN_A))
                      | ERRCOURT := (ERRCOURT_A when MAIN_A) default (ERRCOURT_B when (not MAIN_A))
                      | VLONG := (VLONG_A when MAIN_A) default (VLONG_B when (not MAIN_A))
                      | ERRLONG := (ERRLONG_A when MAIN_A) default (ERRLONG_B when (not MAIN_A))
                      | RAZ_B := SECONDRAZ when MAIN_A
                      | RAZ_A := SECONDRAZ when (not MAIN_A)
                      |)
                   |)/ MAIN_A |)
               where 
               boolean BASCULE, ZBASCULE init true, MAIN_A init true;
               end
            ; 
            process MODELE2 =
                 { integer M, FENETRE; }
                 ( ? real Y;
                     event SRAZ;
                   ! real VCOURT, ERRCOURT, VLONG, ERRLONG;
                 )
               (| HY := ^Y
                | RAZ := HY when SRAZ
                | ORDRE := M when HY
                | (| N := FENETRE when HY
                   | Y ^= V_C ^= ERR_C
                   | (V_C,ERR_C) := AUTO2(NY,Y,ORDRE,N)
                   |)
                | (| RAZY := (SRAZ default false) when HY
                   | Y ^= V_L ^= ERR_L
                   | (V_L,ERR_L) := BURG2(NY,Y,ORDRE,RAZY)
                   |)
                | NY := COMPTEUR_AFTER_RAZ(HY,RAZ)
                | (| ACTIF := NY>=FENETRE
                   | VCOURT := (V_C cell ACTIF) when ACTIF
                   | ERRCOURT := (ERR_C cell ACTIF) when ACTIF
                   | VLONG := (V_L cell ACTIF) when ACTIF
                   | ERRLONG := (ERR_L cell ACTIF) when ACTIF
                   |)
                |)
               where 
               integer ORDRE, N;
               boolean RAZY;
               integer NY;
               boolean ACTIF;
               event HY, RAZ;
               real V_C, ERR_C, V_L, ERR_L;
               process BURG2 =
                    ( ? integer K;
                        real Y;
                        integer M;
                        boolean RAZ;
                      ! real VARA, RES;
                    )
                    spec (| K ^= Y ^= M ^= RAZ ^= VARA ^= RES |)
               
               ; 
               process AUTO2 =
                    ( ? integer NY;
                        real Y;
                        integer M;
                        integer N;
                      ! real ALPH, XAU;
                    )
               
               ; 
               end
            ; 
            process MODELE3 =
                 { integer M, FENETRE; }
                 ( ? real Y;
                     event SRAZ;
                   ! real VCOURT, ERRCOURT, VLONG, ERRLONG;
                 )
               (| HY := ^Y
                | RAZ := HY when SRAZ
                | ORDRE := M when HY
                | (| N := FENETRE when HY
                   | Y ^= V_C ^= ERR_C
                   | (V_C,ERR_C) := AUTO3(NY,Y,ORDRE,N)
                   |)
                | (| RAZY := (SRAZ default false) when HY
                   | Y ^= V_L ^= ERR_L
                   | (V_L,ERR_L) := BURG3(NY,Y,ORDRE,RAZY)
                   |)
                | (| NY := COMPTEUR_AFTER_RAZ(HY,RAZ) |)
                | (| ACTIF := NY>=FENETRE
                   | VCOURT := (V_C cell ACTIF) when ACTIF
                   | ERRCOURT := (ERR_C cell ACTIF) when ACTIF
                   | VLONG := (V_L cell ACTIF) when ACTIF
                   | ERRLONG := (ERR_L cell ACTIF) when ACTIF
                   |)
                |)
               where 
               integer ORDRE, N;
               boolean RAZY;
               integer NY;
               boolean ACTIF;
               event HY, RAZ;
               real V_C, ERR_C, V_L, ERR_L;
               process BURG3 =
                    ( ? integer K;
                        real Y;
                        integer M;
                        boolean RAZ;
                      ! real VARA, RES;
                    )
               
               ; 
               process AUTO3 =
                    ( ? integer NY;
                        real Y;
                        integer M;
                        integer N;
                      ! real ALPH, XAU;
                    )
               
               ; 
               end
            ; 
            process SONDERAZTEST =
                 ( ? boolean RAZTEST;
                 )
            
            ; 
            process SONDEMAXHKF =
                 ( ? real MAXHKF;
                 )
            
            ; 
            process SONDEUHKF =
                 ( ? real UHKF;
                 )
            
            ; 
            process FRONTIERE_P =
                 { real SEUIL; }
                 ( ? real U;
                     real MAX;
                     event HY;
                     event NOUVMAX;
                   ! event RAZTEST;
                     event SWITCH;
                     event SECONDRAZ;
                     integer FRONTIERE;
                     integer F_EVENTUELLE;
                 )
               (| (| (| A2 := HU
                      | A1 := SWITCH
                      | FBY{}
                      | RAZTEST := K
                      |) where event K, A1, A2; end
                   | (| CADENCE := HY
                      | (| C := NOUVMAX default DETECTION
                         | CC := DIFFERER_EVT(CADENCE,C)
                         |)
                      | SECONDRAZ := CC
                      |) where event CADENCE, CC; end/ C
                   | (| SEUIHKF := SEUIL when HU
                      | SONDESEUIHKF(SEUIHKF)
                      |)/ SEUIHKF
                   | (| C := DETECTION
                      | CADENCE := HY
                      | DIFFERER_EVT{}
                      | SWITCH := CC
                      |) where event CADENCE, CC, C; end
                   | (| POS_MAX := (0 when (NY=1)) default (NY when NOUVMAX)
                      | F_EVENTUELLE := POS_MAX cell HY
                      | FRONTIERE := F_EVENTUELLE when DETECTION
                      | NY := counterOf(HY)
                      |)/ POS_MAX, NY
                   | (| DETECTION := when ((MAX-U)>=SEUIL)
                      | HU := ^U
                      |)
                   |)/ HU, DETECTION |)
               where 
               integer POS_MAX, NY;
               event HU, C, DETECTION;
               use LIB_COUNTER; 
               process SONDESEUIHKF =
                    ( ? real SEUIHKF;
                    )
               
               ; 
               process FBY =
                    ( ? event A1, A2;
                      ! event K;
                    )
                  pragmas 
                     COMMENT " This process delays the event A1 to "
                             " an event K until the next event A2."
                             " is send if the 2 signals are both presents. "
                  end pragmas
                  (| C := (not A2) default A1
                   | ZC := C$1
                   | K := A2 when (A1 default ZC)
                   |)
                  where 
                  boolean C, ZC init false;
                  end
               ; 
               real SEUIHKF;
               end
            ; 
            process MAX_P =
                 ( ? real U;
                     boolean SRAZ;
                   ! real MAX;
                     event NOUVMAX;
                 )
               pragmas 
                  COMMENT " This process calculates the current maximum"
                          " of the HINKLEY' s statistic"
               end pragmas
               (| RAZ := (^U) when SRAZ
                | U ^= ZZMAX
                | ZMAX := MAX$1
                | ZZMAX := (U when RAZ) default ZMAX
                | NOUVMAX := when (U>=ZZMAX)
                | MAX := (U when NOUVMAX) default ZZMAX
                |)
               where 
               event RAZ;
               real ZMAX init 0e0, ZZMAX;
               end
            ; 
            end
         ; 
         process SONDEFILTRE =
              ( ? real PAROLE;
              )
         
         ; 
         process FILTRAGE =
              { integer NFILT; }
              ( ? real Y;
                  real H;
                ! real YFILT;
              )
            (| (| (| WWY := Y window (NFILT+1)
                   | WY := WWY when ACTIF
                   |)/ WWY
                | (| WWH := H window NFILT
                   | WH := (WWH cell ACTIF init [{ to (NFILT-1)}:0.0]) when ACTIF
                   |)/ WWH
                | (| array J to NFILT-1
                     of PLUS := PLUS[?]+(WH[(NFILT-1)-J]*WY[J])
                     with (| PLUS := 0e0 |)
                     end 
                   | YFILT := (PLUS default 0e0) when (^Y)
                   |)/ ZERO, PLUS
                | (| NY ^= H ^= Y when (not ACTIF)
                   | NY := ZNY+1
                   | ZNY := NY$1 init 0
                   | NINACTIF := when (NY<NFILT)
                   | NACTIF := (not NINACTIF) default (^Y)
                   | ACTIF := NACTIF$1
                   |)/ NINACTIF, NACTIF, NY, ZNY
                |)/ ACTIF, WH, WY |)
            where 
            [NFILT+1]real WWY init [{ to NFILT}:0.0], WY;
            [NFILT]real WH, WWH init [{ to (NFILT-1)}:0.0];
            real PLUS, ZERO;
            integer ZNY init 0, NY;
            boolean ACTIF init false, NACTIF;
            event NINACTIF;
            end
         ; 
         YFILT;
         end
      ; 
      process MODULE_FORWARD_BACKWARD =
           { integer KMIN, LIMITEBAK, MAXTAB; }
           ( ? integer F_HKF;
               integer NUMF;
               event CSYNC;
               real PAROLE;
             ! integer NUM;
               integer VOIS;
           )
         (| (| (| VT_TEST_HINKLEY{KMIN}
                | F_EVENTUELLE_1 := F_EVENTUELLE
                | DETECTION_2 := DETECTION
                |) where integer F_EVENTUELLE;
                         event DETECTION; end
             | (| VT_TEST_VOISEMENT{KMIN}
                | F_EVENTUELLE_3 := F_EVENTUELLE
                | DETECTION_4 := DETECTION
                |) where integer F_EVENTUELLE;
                         event DETECTION; end
             | (| DET_V := DETECTION_4
                | LSEG_V := F_EVENTUELLE_3
                | DET_HK := DETECTION_2
                | LSEG_HK := F_EVENTUELLE_1
                | HRAPIDE := CSYNC
                | GESTION_INFO{KMIN}
                |) where event HRAPIDE, DET_HK, DET_V;
                         integer LSEG_HK, LSEG_V; end
             | GESTION_MEMOIRE{KMIN,LIMITEBAK,MAXTAB}
             | (| SONDEYCOUR(YCOUR)
                | SONDESENSCOUR(SENSCOUR)
                | HRA := not SENSCOUR
                | SONDEHRA(HRA)
                |)
             | (| VOIS1 := VOIS_1
                | (| OKVOISE := VOIS1=2
                   | HNUM := ^NUM
                   | VOIS2 := (VOIS1 cell HNUM) when HNUM
                   | ZNUM := NUM$1 init (-1)
                   | NUM := ZNUM+LSEGMENTVALIDE
                   |)
                | VOIS := VOIS2
                |) where integer VOIS2, VOIS1; end/ HNUM
                                             / ZNUM
             |)/ OKVOISE, LSEGMENTVALIDE, SWITCH_FB, SENSCOUR, REDEMARRAGE, YCOUR, LSEGMENTB, LSEGMENTF, QUI, DETECTION_4, F_EVENTUELLE_3, VOIS_1, DETECTION_2, F_EVENTUELLE_1 |)
         where 
         boolean HRA, REDEMARRAGE, SENSCOUR init true, OKVOISE;
         process GESTION_MEMOIRE =
              { integer KMIN, LIMITEBAK, MAXTAB; }
              ( ? event CSYNC;
                  real PAROLE;
                  integer LSEGMENTB;
                  integer LSEGMENTF;
                  boolean OKVOISE;
                  integer QUI;
                ! boolean SENSCOUR init true;
                  real YCOUR init 0e0;
                  boolean REDEMARRAGE;
                  event SWITCH_FB;
                  integer LSEGMENTVALIDE;
              )
            (| (| (| Y := PAROLE
                   | AUTOREPRODUCTION{MAXTAB}
                   |) where real Y; end
                | (| LSEGMENTBI := LSEGMENTB
                   | GESTION_INDICES{LIMITEBAK,MAXTAB}
                   |) where integer LSEGMENTBI; end
                | RETARDS{}
                | (| HENTREE := HPAROLE
                   | (| SONDEIDEB(IDEB)
                      | SONDEHENTREE(HENTREE)
                      | HREPRISE := REPRISECOUR and SENSCOUR
                      | SONDEHREPRISE(^HREPRISE)
                      |)
                   |) where event HENTREE; end
                | OK_BACK{KMIN}
                |)/ DMIN, OKB, FINRETOURARRIERE, HPAROLE, REPRISECOUR, IDEB, IFIN, DIRECT, YY, REPRISE, LREPRISE |)
            where 
            boolean HREPRISE, REPRISE, DIRECT, REPRISECOUR init false, OKB;
            integer LREPRISE, IFIN, IDEB, DMIN;
            process GESTION_INDICES =
                 { integer LIMITEBAK, N; }
                 ( ? event HPAROLE;
                     integer LSEGMENTF;
                     boolean OKB;
                     integer DMIN;
                     event FINRETOURARRIERE;
                     integer LSEGMENTBI;
                   ! integer IDEB;
                     integer IFIN;
                     integer LSEGMENTVALIDE;
                 )
               (| (| (| CADENCE := HPAROLE
                      | (| L := ^LSEGMENTF
                         | NAJOUTES := COMPTEUR_DIFF(CADENCE,L)
                         | CIDEB := (ZIDEB cell L) when L
                         | IJ := CIDEB-NAJOUTES
                         | I1 := IJ+LSEGMENTF
                         | IREP := (I1 when (not OKB)) default ((I1-1) when OKB)
                         | J1 := N when (not OKB)
                         | JREP := J1 default ((IJ+LIMITEBAK) when OKB)
                         |)
                      |) where event CADENCE; end/ L
                                             / NAJOUTES
                                             / CIDEB
                                             / I1
                                             / IJ
                                             / J1
                   | (| HLSEGMENTBI := ^LSEGMENTBI
                      | DISTMIN := (DMIN cell HLSEGMENTBI) when HLSEGMENTBI
                      | CCIDEB := (ZIDEB cell HLSEGMENTBI) when HLSEGMENTBI
                      | D1 := CCIDEB-LSEGMENTBI
                      | CCIFIN := (ZIFIN cell HLSEGMENTBI) when HLSEGMENTBI
                      | D2 := CCIFIN-LIMITEBAK
                      | ACCEPTE := D1>=(D2+DISTMIN)
                      | FINRA := FINRETOURARRIERE default (when (not ACCEPTE))
                      | CCCIDEB := (ZIDEB cell FINRA) when FINRA
                      | IAB := CCCIDEB+1
                      | CCCIFIN := (ZIFIN cell FINRA) when FINRA
                      | LSEGMENTB := IAB-(CCCIFIN-LIMITEBAK)
                      | ZERO := 0 when HLSEGMENTBI
                      | IREPAB := IAB default (((CCIDEB-LSEGMENTBI)+1) when ACCEPTE) default ZERO
                      | JREPAB := (N when FINRA) default (CCIFIN when ACCEPTE) default ZERO
                      | LSEGMENTVALIDE := (LSEGMENTF when (not OKB)) default LSEGMENTB
                      |)/ FINRA, ACCEPTE, HLSEGMENTBI, CCCIFIN, CCIFIN, CCCIDEB, CCIDEB, LSEGMENTB, ZERO, IAB, D1, DISTMIN
                   | (| IDEB := IREP default IREPAB
                      | ZIDEB := IDEB$1
                      | IFIN := JREP default JREPAB
                      | ZIFIN := IFIN$1
                      |)
                   |)/ ZIFIN, ZIDEB, IREPAB, JREPAB, IREP, JREP |)
               where 
               boolean ACCEPTE;
               event FINRA, HLSEGMENTBI, L;
               integer ZERO, CCIFIN, CCCIFIN, CCIDEB, D1, D2, DISTMIN, IAB, NAJOUTES, CIDEB init N+1, I1, IJ, J1, JREP, IREP, JREPAB, IREPAB, LSEGMENTB, CCCIDEB, ZIDEB init N+1, ZIFIN init 1;
               process COMPTEUR_DIFF =
                    ( ? event CADENCE;
                        event L;
                      ! integer DIFFN;
                    )
                  pragmas 
                     COMMENT " This process counts the number of events"
                             " (CADENCE). The counter (NCADENCE) is"
                             " resynchronized with the signal (L)' s clock. "
                             " The output (DIFFN) is the nuber of events "
                             " (CADENCE) arrived since the last event (L)."
                  end pragmas
                  (| NCADENCE := counterOf(CADENCE)
                   | NB := (NCADENCE cell L) when L
                   | ZNB := NB$1
                   | DIFFN := NB-ZNB
                   |)
                  where 
                  integer NCADENCE, NB, ZNB init 0;
                  process counterOf =
                       ( ? event H;
                         ! integer N;
                       )
                     (| N := ZN+1
                      | ZN := N$1 init 0
                      | N ^= H
                      |)
                     where 
                     integer ZN;
                     end
                  ; 
                  end
               ; 
               end
            ; 
            process SONDEIDEB =
                 ( ? integer IDEB;
                 )
            
            ; 
            process AUTOREPRODUCTION =
                 { integer N; }
                 ( ? integer IFIN, IDEB;
                     real Y;
                     event CSYNC;
                   ! boolean DIRECT;
                     integer LREPRISE;
                     boolean REPRISE;
                     real YY;
                 )
               pragmas 
                  COMMENT " This process oversamples the input signal Y "
                          " to the signal YY. Y is stored in a slipping window."
                          " When the signals IDEB and IFIN are present, the "
                          " process reinjectes all the samples including "
                          " between IDEB and IFIN of the window. The "
                          " parameter N is the size of the slipping window "
                          " The signal DIRECT indicates the direction "
                          " of the reinjection (or recovery); it gets true "
                          " when IDEB<= IFIN, else false. The signal L is"
                          " the length of the recovery to do. The signal INCR "
                          "is the value of the incrementation"
               end pragmas
               (| (| (| WY := Y window N
                      | WWY := (WY cell REPRISE) when REPRISE
                      | YY := Y default WWY[IREP-1]
                      | Y ^= when (not REPRISE)
                      | YY ^= CSYNC
                      |)/ WWY, WY
                   | (| CINCR := (INCR cell REPRISE) when REPRISE
                      | ZIREP := IREP$1
                      | IREP := (IDEB when REPRISE) default (ZIREP+CINCR)
                      |)/ CINCR, ZIREP
                   | (| LREPRISE := L default (ZLREPRISE-1)
                      | REPRISE := LREPRISE>0
                      | ZLREPRISE := LREPRISE$1 init 0
                      |)/ ZLREPRISE
                   | (| DIRECT := IDEB<=IFIN
                      | INCR := (1 when DIRECT) default ((-1) when (^DIRECT))
                      | L := (((IFIN-IDEB) when DIRECT) default (IDEB-IFIN))+1
                      |)
                   |)/ L, INCR, IREP |)
               where 
               integer ZLREPRISE init 0, L, CINCR, INCR, IREP, ZIREP;
               [N]real WWY, WY;
               end
            ; 
            process SONDEHENTREE =
                 ( ? event HENTREE;
                 )
            
            ; 
            process SONDEHREPRISE =
                 ( ? event HREPRISE;
                 )
            
            ; 
            process RETARDS =
                 ( ? boolean DIRECT;
                     real YY;
                     integer LREPRISE;
                     boolean REPRISE;
                   ! boolean REDEMARRAGE;
                     event SWITCH_FB;
                     real YCOUR init 0e0;
                     boolean SENSCOUR init true, REPRISECOUR init false;
                     event HPAROLE;
                     event FINRETOURARRIERE;
                 )
               (| (| (| (| CADENCE := HRAPIDE
                         | (| ONVASEMETTREF := when DIRECT
                            | ONSEMETF := DIFFERER_EVT(CADENCE,ONVASEMETTREF)
                            | ONVASEMETTREB := when (not DIRECT)
                            | ONSEMETB := DIFFERER_EVT(CADENCE,ONVASEMETTREB)
                            | REDEMARRAGE := ONSEMETF default (not ONSEMETB)
                            | (| ZSWITCH := REDEMARRAGE$1 init true
                               | SWITCH_FB := when (REDEMARRAGE/=ZSWITCH)
                               |)
                            |)
                         |)/ ONVASEMETTREF, ZSWITCH, ONVASEMETTREB, ONSEMETB, ONSEMETF |) where event CADENCE; end
                   | (| REPRISECOUR := REPRISE$1 init false
                      | HPAROLE := when (not REPRISECOUR)
                      | LREPRISECOUR := LREPRISE$1 init (-1)
                      | FINRETOURARRIERE := when ((LREPRISECOUR=1) and (not SENSCOUR))
                      |)/ LREPRISECOUR
                   | (| SENS := (DIRECT cell HRAPIDE init true) when HRAPIDE
                      | SENSCOUR := SENS$1 init true
                      | HRAPIDE := ^YY
                      | YCOUR := YY$1 init 0.0
                      |)/ SENS
                   |)/ HRAPIDE |)
               where 
               boolean SWITCH, ZSWITCH init true, SENS init true;
               event ONSEMETF, ONSEMETB, ONVASEMETTREB, ONVASEMETTREF, HRAPIDE;
               integer LREPRISECOUR init -1;
               end
            ; 
            process OK_BACK =
                 { integer KMIN; }
                 ( ? integer LSEGMENTF;
                     integer QUI;
                     boolean OKVOISE;
                   ! boolean OKB;
                     integer DMIN;
                 )
               (| (| (| HSEGMENTF := ^LSEGMENTF
                      | VOISE := (OKVOISE cell HSEGMENTF init false) when HSEGMENTF
                      | VOISEPREC := VOISE$1 init false
                      | LMIN := (((4*KMIN) when ((QUI=1) or VOISEPREC)) default (2*KMIN)) when HSEGMENTF
                      | DMIN := (((2*KMIN) when (QUI=1)) default (KMIN when VOISEPREC) default (KMIN/2)) when HSEGMENTF
                      | OKB_1 := (LSEGMENTF>=LMIN) and VOISE
                      |)/ LMIN, VOISE, HSEGMENTF, VOISEPREC
                   | (| OK_IN := OKB_1
                      | DEBUG_RA{}
                      | OKB := OK_OUT
                      |) where boolean OK_OUT, OK_IN; end
                   |)/ OKB_1 |)
               where 
               boolean ACCEPTE, VOISEPREC init false, VOISE init false, OKB_1;
               event FINRA, HLSEGMENTBI, HSEGMENTF;
               integer ZERO, CCIFIN, CCCIFIN, CCIDEB, D1, D2, DISTMIN, IAB, LMIN;
               process DEBUG_RA =
                    ( ? boolean OK_IN;
                      ! boolean OK_OUT;
                    )
                  (| HOK_IN := ^OK_IN
                   | CHOIX := DEBUG_PANEL{1}(HOK_IN)
                   | BRANCHE := CHOIX=1
                   | OK_OUT := OK_IN and BRANCHE
                   |)
                  where 
                  event HOK_IN;
                  boolean BRANCHE;
                  integer CHOIX;
                  process DEBUG_PANEL =
                       { integer NOPANEL; }
                       ( ? event HE;
                         ! integer CHOIX;
                       )
                     pragmas 
                        COMMENT " This process uses an extern "
                                " process PANELGETCHOIX."
                                " This one is blind with the switch"
                                "  NOPANEL. If HE is present the "
                                " PANELGETCHOIX' s output : CHOIX "
                                " gets the value associated to the switch"
                     end pragmas
                     (| NO := NOPANEL when HE
                      | CHOIX := PANELGETCHOIX(NO)
                      | NO ^= CHOIX
                      |)
                     where 
                     integer NO;
                     function PANELGETCHOIX =
                          ( ? integer NOPANEL;
                            ! integer CHOIX;
                          )
                     
                     ; 
                     end
                  ; 
                  end
               ; 
               end
            ; 
            real YY;
            event HPAROLE, FINRETOURARRIERE;
            end
         ; 
         process GESTION_INFO =
              { integer KMIN; }
              ( ? integer NUM, F_HKF, NUMF;
                  event HRAPIDE;
                  boolean REDEMARRAGE;
                  integer LSEG_V;
                  event DET_V;
                  integer LSEG_HK;
                  event DET_HK;
                  event SWITCH_FB;
                ! integer LSEGMENTF, QUI, LSEGMENTB;
              )
            (| (| COMMUT_FB{}
                | GESTION_INFO_BACKWARD{}
                | (| DET_HK := DET_HK_FOR
                   | LSEG_HK := LSEG_HK_FOR
                   | GESTION_INFO_FORWARD{}
                   |) where integer LSEG_HK;
                            event DET_HK; end
                | (| NUMF1 := NUMF
                   | F_HKF1 := F_HKF
                   | INTERFACE_FILTRE{5,(2*KMIN)+2}
                   |) where integer F_HKF1, NUMF1; end
                |)/ DET_HKF, LSEG_HKF, DET_HK_BAK, LSEG_HK_BAK, DET_HK_FOR, LSEG_HK_FOR |)
            where 
            process INTERFACE_FILTRE =
                 { integer NF, BMAX; }
                 ( ? integer NUM, F_HKF1, NUMF1;
                     event HRAPIDE;
                   ! integer LSEG_HKF;
                     boolean DET_HKF;
                 )
               (| DNUM := DIFFERER_INT(HRAPIDE,NUM)
                | HREDEMARRAGE := ^DNUM
                | NUMF := DIFFERER_INT(HRAPIDE,NUMF1)
                | F_HKF := DIFFERER_INT(HRAPIDE,F_HKF1)
                | (| WNUMF := NUMF window NF
                   | WWNUMF := (WNUMF cell HREDEMARRAGE) when HREDEMARRAGE
                   | HREDEMARRAGE ^= VAL
                   | I := (NF-1)..0 step (-1)
                   | iterate I
                     of VAL := (WWNUMF[I] when (WWNUMF[I]>(DNUM+BMAX+1))) default VAL[?]
                     with (| VAL := 0 |)
                     end 
                   | FRONTIEREF := VAL
                   | PRESENTF := VAL/=0
                   |)
                | (| MMINNUMF := DNUM+BMAX+1
                   | HNUMF := ^NUMF
                   | MINNUMF := (MMINNUMF cell HNUMF) when HNUMF
                   | DET_HKF := PRESENTF default (not HREDEMARRAGE) default (NUMF>MINNUMF)
                   |)
                | (| HF_HKF := ^F_HKF
                   | DDET_HKF := (DET_HKF cell HF_HKF init false) when HF_HKF
                   | DDNUM := (DNUM cell HF_HKF init 0) when HF_HKF
                   | LSEG_HKF := ((FRONTIEREF-DNUM) when PRESENTF) default (0 when (not PRESENTF)) default ((F_HKF-DDNUM) when (not DDET_HKF))
                   |)
                |)
               where 
               boolean HCALCUL, PRESENTF, DDET_HKF init false, HREDEMARRAGE, HNUMF, HF_HKF;
               integer NUMF, F_HKF, DNUM, FRONTIEREF, MINNUMF, MMINNUMF, DDNUM init 0, VAL;
               [NF]integer WNUMF init [{ to (NF-1)}:0], WWNUMF init [{ to NF}:0], I;
               process DIFFERER_INT =
                    ( ? boolean CADENCE;
                        integer C;
                      ! integer CC;
                    )
                  pragmas 
                     COMMENT " This process delay the signal (C, CC : integer) "
                             "of one clock's event (of CADENCE' s clock). "
                             " The new signal names CC "
                  end pragmas
                  (| PRESENT := (((^C) default (not (^CADENCE))) cell (^CADENCE)) when (^CADENCE)
                   | ZPRESENT := PRESENT$1
                   | REINIT := ((C default ZREINIT) cell (^CADENCE) init 0) when (^CADENCE)
                   | ZREINIT := REINIT$1
                   | CC := (ZREINIT cell ZPRESENT init 0) when ZPRESENT
                   |)
                  where 
                  integer REINIT, ZREINIT;
                  boolean PRESENT, ZPRESENT init false;
                  end
               ; 
               end
            ; 
            process COMMUT_FB =
                 ( ? event SWITCH_FB;
                     integer LSEG_HK;
                     event DET_HK;
                   ! integer LSEG_HK_FOR;
                     event DET_HK_FOR;
                     integer LSEG_HK_BAK;
                     event DET_HK_BAK;
                 )
               (| (| (| SWITCH_FB ^= BASCULE
                      | BASCULE := not ZBASCULE
                      | ZBASCULE := BASCULE$1
                      |)
                   | HLSEG_HK := ^LSEG_HK
                   | MAINFOR := (BASCULE cell HLSEG_HK init true) when HLSEG_HK
                   |)
                | LSEG_HK_FOR := LSEG_HK when MAINFOR
                | DET_HK_FOR := DET_HK when MAINFOR
                | LSEG_HK_BAK := LSEG_HK when (not MAINFOR)
                | DET_HK_BAK := DET_HK when (not MAINFOR)
                |)
               where 
               boolean BASCULE, ZBASCULE init true, MAINFOR init true, HLSEG_HK;
               end
            ; 
            process GESTION_INFO_FORWARD =
                 ( ? integer LSEG_HKF;
                     boolean DET_HKF;
                     integer LSEG_V;
                     event DET_V;
                     boolean REDEMARRAGE;
                     integer LSEG_HK;
                     event DET_HK;
                   ! integer LSEGMENTF, QUI;
                 )
               (| HFORWARD := (^LSEG_HK) default (^LSEG_V) default (^LSEG_HKF)
                | RAZ := (^REDEMARRAGE) when (^HFORWARD)
                | LSEGHK := LSEG_HK cell (^HFORWARD)
                | LSEGV := LSEG_V cell (^HFORWARD)
                | LSEGHKF := LSEG_HKF cell (^HFORWARD)
                | PRESENTHK := ((not (^RAZ)) default DET_HK) cell (^HFORWARD)
                | PRESENTV := ((not (^RAZ)) default DET_V) cell (^HFORWARD)
                | PRESENTHKF := (DET_HKF cell (^HFORWARD) init false) when (^HFORWARD)
                | HKINF := LSEGHK<=LSEGHKF
                | VINF := LSEGV<=LSEGHKF
                | HKFINF := ((LSEGHKF<=LSEGHK) and PRESENTHK) or ((LSEGHKF<=LSEGV) and PRESENTV)
                | LSEGMENTF := (LSEGHK when (HKINF and PRESENTHK)) default (LSEGV when (VINF and PRESENTV)) default (LSEGHKF when (HKFINF and PRESENTHKF))
                | QUI := (0 when (HKINF and PRESENTHK)) default (1 when (VINF and PRESENTV)) default (2 when (HKFINF and PRESENTHKF))
                |)
               where 
               boolean HFORWARD, PRESENTHK init false, PRESENTV init false, PRESENTHKF init false, HKINF, VINF, HKFINF, RAZ;
               integer LSEGHK, LSEGV, LSEGHKF;
               end
            ; 
            process GESTION_INFO_BACKWARD =
                 ( ? integer LSEG_HK_BAK;
                     event DET_HK_BAK;
                   ! integer LSEGMENTB;
                 )
               (| LSEGMENTB := LSEG_HK_BAK when DET_HK_BAK |)
            ; 
            integer LSEG_HK_FOR, LSEG_HK_BAK, LSEG_HKF;
            event DET_HK_FOR, DET_HK_BAK;
            boolean DET_HKF;
            end
         ; 
         process VT_TEST_VOISEMENT =
              { integer KMIN; }
              ( ? real YCOUR;
                  boolean REDEMARRAGE;
                  boolean SENSCOUR;
                ! integer VOIS_1;
                  integer F_EVENTUELLE;
                  event DETECTION;
              )
            (| (| (| WY := WWY
                   | CALCUL_VOISEMENT{2.1e5/1.28e2,8.5e6/1.28e2,1.9e5/1.28e2,5.5e6/1.28e2,8e1/2.56e2,KMIN/2}
                   |) where [KMIN/2]real WY; end
                | (| STOPV := DETECTION
                   | ALIM{KMIN}
                   |) where event STOPV; end
                | (| VOIS := VOISEMENT
                   | OUT{KMIN}
                   | VOIS_1 := VOIS1_1_1
                   |) where integer VOIS1_1_1, VOIS; end
                | (| VOIS1_1 := VOISEMENT
                   | SONDEVOIS1{}
                   |) where integer VOIS1_1; end
                |)/ NY, INFPREMIERTEST, PREMIERTEST, NBTESTS, WWY, VOISEMENT |)
            where 
            integer VOIS1_1, VOIS1_1_1, VOIS, VOISEMENT, NBTESTS, NY;
            process SONDEVOIS1 =
                 ( ? integer VOIS1_1;
                 )
            
            ; 
            process OUT =
                 { integer KMIN; }
                 ( ? event PREMIERTEST;
                     integer VOIS;
                     integer NBTESTS;
                     event INFPREMIERTEST;
                     integer NY;
                   ! integer VOIS1_1_1;
                     event DETECTION;
                     integer F_EVENTUELLE;
                 )
               (| (| (| (| VOIS1 := VOIS when PREMIERTEST
                         | (| (| ZNVOISC := NVOISC$1
                               | ZZNVOISC := (0 when PREMIERTEST when (^VOIS)) default ZNVOISC
                               |)
                            | (| ZDERNIERV := VOIS$1
                               | ZZDERNIERV := VOIS1 default ZDERNIERV
                               |)
                            | (| ZAVDERNIERV := AVDERNIERV$1
                               | ZZAVDERNIERV := (VOIS1 default ZAVDERNIERV) when (^VOIS)
                               |)
                            | C1 := ZZDERNIERV=VOIS
                            | C2 := ZZAVDERNIERV=ZZDERNIERV
                            | C3 := ZZAVDERNIERV=VOIS
                            | C4 := (NVOISC>4) and (NVOISC/=NBTESTS)
                            | NVOISC := ((ZZNVOISC+1) when C1) default (NBTESTS when C3) default (1 when (^VOIS))
                            | AVDERNIERV := (ZZAVDERNIERV when (C1 or C2 or C3)) default ZZDERNIERV
                            | NRU := (0 when (C1 and (ZZNVOISC=(NBTESTS-1)))) default (ZZNVOISC when (C1 and (ZZNVOISC=(NBTESTS-2)))) default ((ZZNVOISC+1) when (C1 and (ZZNVOISC/=(NBTESTS-1)))) default (1 when C2) default (0 when C3) default (ZZNVOISC+1)
                            | DETECTION := when ((C1 and C4) or ((not C1) and (not C2) and (not C3)))
                            | LSEGACTIF := ((NBTESTS+1)-NRU)*(KMIN/4)
                            |)
                         |)
                      | VOIS1_1_1 := VOIS1
                      |) where integer VOIS1; end
                   | (| LSEGACTIFNY := LSEGACTIF cell (^NY)
                      | F_EVENTUELLE := (NY when INFPREMIERTEST) default LSEGACTIFNY
                      |)/ LSEGACTIFNY
                   |)/ LSEGACTIF |)
               where 
               boolean C1, C2, C3, C4;
               integer VOIS1, LSEGACTIFNY, NVOISC, ZNVOISC, ZZNVOISC, NRU, DERNIERV, ZDERNIERV, ZZDERNIERV, AVDERNIERV, ZAVDERNIERV, ZZAVDERNIERV, LSEGACTIF;
               end
            ; 
            process ALIM =
                 { integer KMIN; }
                 ( ? boolean REDEMARRAGE;
                     real YCOUR;
                     event STOPV;
                     boolean SENSCOUR;
                   ! event PREMIERTEST;
                     [KMIN/2]real WWY;
                     integer NBTESTS;
                     event INFPREMIERTEST;
                     integer NY;
                 )
               (| (| (| C := STOPV
                      | Y := YCOUR
                      | (| CADENCE := ^Y
                         | CIN := when REDEMARRAGE
                         | COUT := DIFFERER_EVT(CADENCE,C)
                         | YY := INTERRUPT(Y,CIN,COUT)
                         | Y_V := YY when SENSCOUR
                         | RAZ_V := CIN when (^Y_V)
                         |)
                      |) where real Y;
                               event C; end/ CADENCE
                                           / COUT
                                           / CIN
                                           / YY
                   | (| RAZ := RAZ_V
                      | Y := Y_V
                      | CONTROLE{KMIN/2,KMIN/4}
                      |) where real Y;
                               boolean RAZ; end
                   |)/ RAZ_V, Y_V |)
               where 
               process CONTROLE =
                    { integer IECH, IIECH; }
                    ( ? boolean RAZ;
                        real Y;
                      ! event PREMIERTEST;
                        [IECH]real WWY;
                        integer NBTESTS;
                        event INFPREMIERTEST;
                        integer NY;
                    )
                  (| (| CADENCE := ^Y
                      | NYMOD := COMPTEUR_MODULO_AFTER_RAZ{IIECH}(CADENCE,RAZ)
                      | NY := COMPTEUR_AFTER_RAZ(CADENCE,RAZ)
                      |)
                   | (| WY := Y window IECH
                      | WWY := WY when ((NY/=IIECH) and (NYMOD=IIECH))
                      |)
                   | INFPREMIERTEST := when (NY<IECH)
                   | (| HWWY := ^WWY
                      | PREMIERTEST := (when (NY=IECH)) when HWWY
                      | NBTESTS := COMPTEUR_AFTER_RAZ(HWWY,PREMIERTEST)
                      |)
                   |)
                  where 
                  event HWWY, CADENCE;
                  integer NYMOD;
                  [IECH]real WY;
                  process COMPTEUR_MODULO_AFTER_RAZ =
                       { integer N; }
                       ( ? event CADENCE;
                           boolean RAZ;
                         ! integer NMOD;
                       )
                     (| CADENCE default (when RAZ) ^= NMOD
                      | NMOD := (1 when ((when RAZ) default (ZNMOD=N))) default (ZNMOD+1)
                      | ZNMOD := NMOD$1
                      |)
                     where 
                     integer ZNMOD init 0;
                     end
                  ; 
                  end
               ; 
               event CADENCE, COUT, CIN, RAZ_V;
               real Y_V, YY;
               end
            ; 
            process CALCUL_VOISEMENT =
                 { real SEUI1, SEUI2, SEUI3, SEUI4, SEUI5;
                   integer FENETRE; }
                 ( ? [FENETRE]real WY;
                   ! integer VOISEMENT;
                 )
               pragmas 
                  COMMENT "This processus associate a mark of voicing "
                          "(VOISEMENT) to the window (WY) which "
                          "contain the signal of the voice."
               end pragmas
               (| (| NB_PASSAGES_ZERO{FENETRE}
                   | AUTOCORRELATION2{1,FENETRE}
                   | (| T2 := ((0 when (R[0]<=SEUI1)) default (1 when (R[0]<=SEUI2)) default 2) when (^WY)
                      | T1 := ((0 when (R[1]<=SEUI3)) default (1 when (R[1]<=SEUI4)) default 2) when (^WY)
                      | T := (T1+T2)/2
                      | CVOIS := ((T=2) and (R[1]<0e0)) or ((T=2) and ((R[1]/R[0])<8.5e-1) and (R[0]<(1e7/1.28e2))) or ((T=0) and ((R[1]/R[0])<7e-1) and (R[0]>(2e4/1.28e2))) or ((T=2) and (T2=2) and (NBCHGT>=integer(SEUI5*real(FENETRE))))
                      | VOISEMENT := (((1 when CVOIS) default T) cell (^WY)) when (^WY)
                      |)
                   |)/ R, NBCHGT |)
               where 
               boolean CVOIS;
               integer T, T1, T2, NBCHGT;
               process NB_PASSAGES_ZERO =
                    { integer FENETRE; }
                    ( ? [FENETRE]real WY;
                      ! integer NBCHGT;
                    )
                  (| array I to FENETRE-1
                     of (| SIGNE[I] := ((-1) when (WY[I]<0e0)) default (1 when (WY[I]>0e0)) default (SIGNE[?][I-1]\\0)
                         | CHGTSIGNE[I] := (((CHGTSIGNE[?][I-1]\\0)+1) when C) default (CHGTSIGNE[?][I-1]\\0)
                         | C := ((SIGNE[I]=1) and (WY[I]<0e0)) or ((SIGNE[I]=(-1)) and (WY[I]>0e0))
                         |)
                     end 
                   | NBCHGT := CHGTSIGNE[FENETRE-1]
                   |)
                  where 
                  [FENETRE]integer SIGNE, CHGTSIGNE;
                  boolean C;
                  end
               ; 
               process AUTOCORRELATION2 =
                    { integer M, FENETRE; }
                    ( ? [FENETRE]real WY;
                      ! [M+1]real R;
                    )
                  (| J := (FENETRE-1)..0 step (-1)
                   | array I to M
                     of (| iterate J
                           of (| CALCUL[I][J] := ((X+(WY[J]*WY[J-I])) when (J>=M)) default X
                               | X := CALCUL[?][I][J+1]
                               |)
                           with (| CALCUL[I][FENETRE] := 0.0 |)
                           end 
                         | R[I] := CALCUL[I][0]/real(FENETRE-M)
                         |)
                     end 
                   |)
                  where 
                  [M+1,FENETRE+1]real CALCUL;
                  [FENETRE]integer J;
                  real X;
                  end
               ; 
               [2]real R;
               end
            ; 
            [KMIN/2]real WWY;
            event PREMIERTEST, INFPREMIERTEST;
            end
         ; 
         process VT_TEST_HINKLEY =
              { integer KMIN; }
              ( ? boolean OKVOISE;
                  real YCOUR;
                  boolean REDEMARRAGE;
                ! event DETECTION;
                  integer F_EVENTUELLE;
              )
            (| (| (| Y := Y_HK
                   | DEBUG_MODELE{0}
                   |) where real Y; end
                | (| RAZ := RAZ_HK
                   | Y := Y_HK
                   | TEST_HINKLEY{KMIN}
                   |) where real Y;
                            event RAZ; end
                | (| SEUIHK := SEUIL
                   | SONDESEUIHK{}
                   |) where real SEUIHK; end
                | (| STOPHK := DETECTION
                   | ALIM{}
                   |) where event STOPHK; end
                |)/ SEUIL, BIAIS, RAZ_HK, Y_HK, ORDRE |)
            where 
            process SONDESEUIHK =
                 ( ? real SEUIHK;
                 )
            
            ; 
            process DEBUG_MODELE =
                 { integer NOPANEL; }
                 ( ? real Y;
                   ! integer ORDRE;
                 )
               (| CHOIX := PANELGETCHOIX(NOPANEL when (^Y))
                | CHOIX16 := CHOIX=1
                | ORDRE := (16 when CHOIX16) default (2 when (not CHOIX16))
                |)
               where 
               boolean CHOIX16;
               integer CHOIX;
               function PANELGETCHOIX =
                    ( ? integer NOPANEL;
                      ! integer CHOIX;
                    )
               
               ; 
               end
            ; 
            process TEST_HINKLEY =
                 { integer KMIN; }
                 ( ? boolean RAZ;
                     real Y;
                     integer ORDRE;
                     real BIAIS, SEUIL;
                   ! integer F_EVENTUELLE;
                     event DETECTION;
                 )
               (| (| (| SRAZ := RAZ
                      | MODELE1{KMIN}
                      |) where boolean SRAZ; end
                   | (| BIAI := (BIAIS cell HERRLONG) when HERRLONG
                      | HERRLONG := ^ERRLONG
                      |)/ HERRLONG
                   | (| SRAZ := RAZTEST
                      | STAT_HINKLEY{}
                      |) where boolean SRAZ; end
                   | (| SRAZ := RAZTEST
                      | MAX_P{}
                      |) where boolean SRAZ; end
                   | (| CADENCE := ^Y
                      | N := COMPTEUR_AFTER_RAZ(CADENCE,RAZ)
                      | RAZTEST := N=KMIN
                      |)/ CADENCE
                   | (| MAXHK := MAX
                      | UHK := U
                      | (| SONDEUHK(UHK)
                         | SONDEMAXHK(MAXHK)
                         |)
                      |) where real UHK, MAXHK; end
                   | (| HU := ^U
                      | SEUI := (SEUIL cell HU) when HU
                      | DETECTION := when ((MAX-U)>=SEUI)
                      |)/ SEUI, HU
                   | (| NY := N
                      | (| POS_MAX := (0 when RAZ) default (NY when NOUVMAX)
                         | F_EVENTUELLE := POS_MAX cell (^NY)
                         |)
                      |) where integer NY; end/ POS_MAX
                   |)/ RAZTEST, N, MAX, NOUVMAX, U, BIAI, ERRLONG, VLONG, ERRCOURT, VCOURT |)
               where 
               process MODELE1 =
                    { integer FENETRE; }
                    ( ? integer ORDRE;
                        real Y;
                        boolean SRAZ;
                      ! real VCOURT, ERRCOURT, VLONG, ERRLONG;
                    )
                  (| HY := ^Y
                   | RAZ := SRAZ when HY
                   | (| N := FENETRE when HY
                      | Y ^= V_C ^= ERR_C
                      | (V_C,ERR_C) := AUTO1(NY,Y,ORDRE,N)
                      |)
                   | (| RAZY := (when RAZ) default (not HY)
                      | Y ^= V_L ^= ERR_L
                      | (V_L,ERR_L) := BURG1(NY,Y,ORDRE,RAZY)
                      |)
                   | NY := COMPTEUR_AFTER_RAZ(HY,RAZ)
                   | (| ACTIF := NY>=FENETRE
                      | VCOURT := (V_C cell ACTIF) when ACTIF
                      | ERRCOURT := (ERR_C cell ACTIF) when ACTIF
                      | VLONG := (V_L cell ACTIF) when ACTIF
                      | ERRLONG := (ERR_L cell ACTIF) when ACTIF
                      |)
                   |)
                  where 
                  integer N;
                  boolean RAZY;
                  integer NY;
                  boolean ACTIF, RAZ;
                  event HY;
                  real V_C, ERR_C, V_L, ERR_L;
                  process BURG1 =
                       ( ? integer K;
                           real Y;
                           integer ORDRE;
                           boolean RAZ;
                         ! real VARA, RES;
                       )
                  
                  ; 
                  process AUTO1 =
                       ( ? integer NY;
                           real Y;
                           integer ORDRE, N;
                         ! real ALPH, XAU;
                       )
                  
                  ; 
                  end
               ; 
               process SONDEUHK =
                    ( ? real UHK;
                    )
               
               ; 
               process SONDEMAXHK =
                    ( ? real MAXHK;
                    )
               
               ; 
               real VCOURT, ERRCOURT, VLONG, ERRLONG, BIAI, U, MAX, SEUI;
               event HERRLONG, CADENCE, HU;
               boolean NOUVMAX, RAZTEST;
               integer N, POS_MAX;
               end
            ; 
            process ALIM =
                 ( ? event STOPHK;
                     real YCOUR;
                     boolean REDEMARRAGE, OKVOISE;
                   ! real Y_HK;
                     event RAZ_HK;
                     real BIAIS, SEUIL;
                 )
               (| (| (| Y := YCOUR
                      | C := STOPHK
                      | (| CIN := ^REDEMARRAGE
                         | COUT := DIFFERER_EVT(CADENCE,C)
                         | YY := INTERRUPT(Y,CIN,COUT)
                         | RAZ_HK := CIN when (^YY)
                         | CADENCE := ^Y
                         |)
                      | Y_HK := YY
                      |) where event C;
                               real Y, YY; end/ CIN
                                             / COUT
                   | (| C := OKVOISE
                      | (| CC := DIFFERER_LOG(CADENCE,C)
                         | ONSEMETB := when (not REDEMARRAGE)
                         | BIAIS := ((-2e-1) when ONSEMETB) default ((-2e-1) when CC) default ((-8e-1) when (not CC))
                         | SEUIL := (4e1 when ONSEMETB) default (4e1 when CC) default (8e1 when (not CC))
                         |)
                      |) where boolean C; end/ ONSEMETB
                                             / CC
                   |)/ CADENCE |)
               where 
               process DIFFERER_LOG =
                    ( ? event CADENCE;
                        boolean C;
                      ! boolean CC;
                    )
                  pragmas 
                     COMMENT " This process delay the signal "
                             "(C, CC : boolean) "
                             " of one clock's event (of CADENCE' s clock). "
                             " The new signal names CC "
                  end pragmas
                  (| PRESENT ^= CADENCE
                   | PRESENT := ((^C) default (not CADENCE)) when CADENCE
                   | ZPRESENT := PRESENT$1
                   | REINIT := ((C default ZREINIT) cell CADENCE) when CADENCE
                   | ZREINIT := REINIT$1
                   | CC := (ZREINIT cell ZPRESENT init false) when ZPRESENT
                   |)
                  where 
                  boolean PRESENT, ZPRESENT init false, REINIT, ZREINIT;
                  end
               ; 
               event CIN, COUT, CADENCE, ONSEMETB;
               boolean CC init false;
               end
            ; 
            process MAX_P =
                 ( ? real U;
                     boolean SRAZ;
                   ! real MAX;
                     event NOUVMAX;
                 )
               (| RAZ := (^U) when SRAZ
                | U ^= ZZMAX
                | ZMAX := MAX$1
                | ZZMAX := (U when RAZ) default ZMAX
                | NOUVMAX := when (U>=ZZMAX)
                | MAX := (U when NOUVMAX) default ZZMAX
                |)
               where 
               event RAZ;
               real ZMAX init 0e0, ZZMAX;
               end
            ; 
            integer ORDRE;
            real Y_HK, BIAIS, SEUIL;
            event RAZ_HK;
            end
         ; 
         process INTERRUPT =
              ( ? real Y;
                  event CIN;
                  event COUT;
                ! real YY;
              )
            pragmas 
               COMMENT " This process sub-sample the input signal (Y)"
                       " to a signal (YY). YY is interupted when COUT"
                       " is present and equal true. "
                       " It will be broadcast "
                       " again when CIN is present and equal true"
                       " If CIN and COUT are both present and equal "
                       " true, we ignore COUT. The clock of CIN, COUT,"
                       "  YY are lower than Y' s clock."
            end pragmas
            (| SWITCH := CIN default (not COUT)
             | SORTIE := SWITCH cell (^Y)
             | YY := Y when SORTIE
             |)
            where 
            boolean SWITCH, SORTIE init true;
            end
         ; 
         process SONDEYCOUR =
              ( ? real YCOUR;
              )
         
         ; 
         process SONDESENSCOUR =
              ( ? boolean SENSCOUR;
              )
         
         ; 
         process SONDEHRA =
              ( ? boolean HRA;
              )
         
         ; 
         integer F_EVENTUELLE_1, F_EVENTUELLE, VOIS_1, F_EVENTUELLE_3, QUI, LSEGMENTF, LSEGMENTB, LSEGMENTVALIDE, ZNUM init -1;
         event DETECTION_2, DETECTION, DETECTION_4, SWITCH_FB, HNUM;
         real YCOUR init 0e0;
         end
      ; 
      process DIFFERER_EVT =
           ( ? event CADENCE;
               event C;
             ! event CC;
           )
         (| PRESENT ^= CADENCE
          | PRESENT := C default (not CADENCE)
          | ZPRESENT := PRESENT$1
          | CC := when ZPRESENT
          |)
         where 
         boolean PRESENT, ZPRESENT init false;
         end
      ; 
      integer F_EVENTUELLE;
      end
   ; 
   event HES;
   integer VOIS;
   end
; 
