
static char police9x15[9] = "9x15bold";
static int lgpolice9x15 = 10;	// size(police9x15)+1

#include "graphical_const.h"

static Widget
mk_label_fixSize (char *nom, Widget pere, int X, int Y)
{
  return (XtVaCreateManagedWidget (nom, xmLabelWidgetClass, pere,
				   XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET),
				   XmNwidth, LABEL_WIDTH, XmNx, X, XmNy, Y, XmNheight, BUTTON_HEIGHT, NULL));
}

static Widget
mk_label (char *nom, Widget fatherw, int X, int Y)
{
  Widget w;
  w = XtVaCreateManagedWidget (nom, xmLabelWidgetClass, fatherw,
			       XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET), XmNx, X, XmNy, Y, NULL);
  XtVaSetValues (w, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
  return w;

}


static Widget
creer_bouton (char *nom, Widget pere, int bordWidth)
{
  return (XtVaCreateManagedWidget (nom, xmPushButtonWidgetClass, pere,
				   XmNborderWidth, bordWidth,
				   XmNwidth, BUTTON_WIDTH, XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET), NULL));
}

static Widget
mk_buttonAt (char *nom, Widget pere, int bordWidth, int X, int Y)
{

  return XtVaCreateManagedWidget (nom, xmPushButtonWidgetClass, pere,
				  XmNborderWidth, bordWidth,
				  XmNlabelString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET), XmNx, X, XmNy, Y, NULL);
}

static Widget
creer_jauge (char *nom, Widget pere, int min, int max)
{
  return (XtVaCreateManagedWidget (nom, xmScaleWidgetClass, pere,
				   XmNtitleString, XmStringCreateLtoR (nom, XmSTRING_DEFAULT_CHARSET),
				   XmNminimum, min,
				   XmNmaximum, max, XmNshowValue, pk_true, XmNorientation, XmHORIZONTAL, XmNscaleHeight, 40, XmNscaleWidth, 200, NULL));
}


static void
mkLeftPanel (Widget pere)
{
  Widget w1, w2;

  w1 = mk_label ("DIVERGENCE TEST", pere, 2, y0_filtered_div - 40);
  XtVaSetValues (w1, XmNleftAttachment, XmATTACH_FORM, XmNrightAttachment, XmATTACH_FORM, NULL);
  w2 = mk_label ("ON FILTERED", pere, 20, y0_filtered_div - 15);
  w1 = mk_label ("SIGNAL", pere, 20, y0_filtered_div);
  w2 = mk_label ("FILTERED SIGNAL", pere, 5, y0_filtered_signal);
  w1 = mk_label ("<FILT.HINK.> JUMP", pere, 20, y0_filtered_jump);
  w2 = mk_label ("VOICE TEST", pere, 30, y0_voice);

  w1 = mk_label ("<HINKLEY> JUMP", pere, 10, y0_input_jump);

  w2 = mk_label ("INPUT SIGNAL", pere, 20, y0_input_signal);

  w1 = mk_label ("DIVERGENCE TEST", pere, 2, y0_input_div_for - 10);
  w2 = mk_label ("(FORWARD)", pere, 20, y0_input_div_for + 5);
  w1 = mk_label ("DIVERGENCE TEST", pere, 2, y0_input_div_back - 10);

  w2 = mk_label ("(BACKWARD)", pere, 20, y0_input_div_back + 5);
}


static void
mk_appli_widget (Widget w)
{
  Widget panel_cadre, panel_gauche_widg, widg, panel_input_widg;

  panel_cadre = XtVaCreateManagedWidget ("panel_cadre", xmFormWidgetClass, w, XmNtopAttachment, XmATTACH_FORM, XmNverticalSpacing, ESP_HEIGHT, NULL);

  panel_gauche_widg = XtVaCreateManagedWidget ("panel_gauche", xmFormWidgetClass, panel_cadre,
					       XmNborderWidth, 1,
					       XmNtopAttachment, XmATTACH_FORM,
					       XmNbottomAttachment, XmATTACH_FORM, XmNverticalSpacing, ESP_HEIGHT, NULL);
  mkLeftPanel (panel_gauche_widg);
  widg = XtVaCreateManagedWidget ("canvas", xmDrawingAreaWidgetClass, panel_cadre,
				  XmNborderWidth, 1,
				  XmNwidth, screen_x,
				  XmNheight, screen_y,
				  XmNtopAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, panel_gauche_widg, NULL);
  canvas_creat (widg);
}



static void
mk_menuBar_panel (Widget pere)
{
  Widget toto, menu_bar0, menu_bar1, menu_bar2;
  XmString xms_nilstr, vstr, xms_1, xms_2, xms_3;

  toto = XtVaCreateManagedWidget ("menuXXX", xmFormWidgetClass, pere, XmNborderWidth, 1, XmNx, 390, XmNy, 30, NULL);
  vstr = XmStringCreateLocalized ("DRAWING ALL XSAMPLES ");
  menu_bar0 = XmVaCreateSimpleMenuBar (toto, "menubar0", XmVaCASCADEBUTTON, vstr, ' ', XmNtopAttachment, XmATTACH_FORM
				       // , XmNleftAttachment,  XmATTACH_FORM
				       // , XmNrightAttachment, XmATTACH_FORM
				       , NULL);

  XmStringFree (vstr);

  /* build the File pulldown menu */

  xms_1 = XmStringCreateLocalized (" 1 ");
  xms_2 = XmStringCreateLocalized (" 4 ");
  xms_3 = XmStringCreateLocalized (" 8 ");
  xms_nilstr = XmStringCreateLocalized ("");

  XmVaCreateSimplePulldownMenu (menu_bar0, "xsamples", 0, proc_drawingallxsamples, XmVaPUSHBUTTON, xms_1, 'O', "", xms_nilstr, XmVaSEPARATOR,
				XmVaPUSHBUTTON, xms_2, 'K', "", xms_nilstr, XmVaSEPARATOR, XmVaPUSHBUTTON, xms_3, 'E', "", xms_nilstr, NULL);

  XmStringFree (xms_1);
  XmStringFree (xms_2);
  XmStringFree (xms_3);

  XtManageChild (menu_bar0);

  //----------------------------
  vstr = XmStringCreateLocalized ("MODELS ORDERS        ");
  menu_bar1 = XmVaCreateSimpleMenuBar (toto, "menubar1", XmVaCASCADEBUTTON, vstr, ' ',
				       XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, menu_bar0, NULL);
  xms_1 = XmStringCreateLocalized ("  2 ");
  xms_2 = XmStringCreateLocalized (" 16 ");

  XmVaCreateSimplePulldownMenu (menu_bar1, "orders", 0, proc_modelsorders, XmVaPUSHBUTTON, xms_1, 'X', "", xms_nilstr, XmVaSEPARATOR, XmVaPUSHBUTTON,
				xms_2, 'X', "", xms_nilstr, NULL);


  XmStringFree (vstr);
  XmStringFree (xms_1);
  XmStringFree (xms_2);

  XtManageChild (menu_bar1);




  //----------------------------
  vstr = XmStringCreateLocalized ("BACKWARD PROCESS     ");
  menu_bar2 = XmVaCreateSimpleMenuBar (toto, "menubar2", XmVaCASCADEBUTTON, vstr, ' ',
				       XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, menu_bar1, NULL);
  xms_1 = XmStringCreateLocalized (" ON ");
  xms_2 = XmStringCreateLocalized (" OFF ");

  XmVaCreateSimplePulldownMenu (menu_bar2, "backwardp", 0, proc_backwardprocess, XmVaPUSHBUTTON, xms_1, 'X', "", xms_nilstr, XmVaSEPARATOR,
				XmVaPUSHBUTTON, xms_2, 'X', "", xms_nilstr, NULL);


  XmStringFree (vstr);
  XmStringFree (xms_1);
  XmStringFree (xms_2);

  XtManageChild (menu_bar2);

}


static void
mkButtons (Widget pere)
{
  Widget wdown, wauto, woff, wup, wisc, wover;
  // OFF button
  woff = mk_buttonAt (" OFF ", pere, 1, PL_X_OFF, PL_Y_OFF);
  XtVaSetValues (woff, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);

  XtAddCallback (woff, XmNactivateCallback, (XtCallbackProc) proc_off, NULL);

  // UP button
  wup = mk_buttonAt (" UP ", pere, 1, PL_X_UP, PL_Y_UP);
  XtAddCallback (wup, XmNactivateCallback, (XtCallbackProc) proc_up, NULL);

  // DOWN button
  wdown = mk_buttonAt ("DOWN", pere, 1, PL_X_DOWN, PL_Y_DOWN);
  XtAddCallback (wdown, XmNactivateCallback, (XtCallbackProc) proc_down, NULL);

  // AUTOMATIC button
  wauto = mk_buttonAt (" AUTOMATIC ", pere, 1, PL_X_AUTO, PL_Y_AUTO);
  XtAddCallback (wauto, XmNactivateCallback, (XtCallbackProc) proc_automatic, NULL);

  // INPUT SIGNAL CLOCK button
  wisc = mk_buttonAt ("INPUT SIGNAL CLOCK", pere, 1, PL_X_ISC, PL_Y_ISC);
  XtAddCallback (wisc, XmNactivateCallback, (XtCallbackProc) proc_inputsignalclock, NULL);


  // OVERSAMPLING CLOCK button
  wover = mk_buttonAt ("OVERSAMPLING CLOCK", pere, 1, PL_X_OVER, PL_Y_OVER);
  XtAddCallback (wover, XmNactivateCallback, (XtCallbackProc) proc_oversamplingclock, NULL);

  mk_menuBar_panel (pere);
}


static void
mk_button_panel (Widget pere)
{
  Widget control_widg;

  control_widg = XtVaCreateManagedWidget ("button_control", xmFormWidgetClass, pere,
					  XmNborderWidth, 1,
					  XmNwidth, bp_width,
					  XmNheight, bp_heigth,
					  XmNtopAttachment, XmATTACH_FORM, XmNrightAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_FORM, NULL);
  mkButtons (control_widg);
}


/*------------------------------------------------------------------------------
  Creating the main window.
 ------------------------------------------------------------------------------*/
static void
mk_main_window (Widget toplevel)
{
  Widget buttonPanel, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget ("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget ("frame", xmFormWidgetClass, cadre_widg, NULL);
  appli_widg = XtVaCreateManagedWidget ("SEGMENTATION", xmFormWidgetClass, frame_widg,
					XmNtopAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_FORM, XmNrightAttachment, XmATTACH_FORM, NULL);
  mk_appli_widget (appli_widg);

  buttonPanel = XtVaCreateManagedWidget ("buttonPanel", xmFormWidgetClass, frame_widg,
					 XmNleftAttachment, XmATTACH_FORM,
					 XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, appli_widg, XmNbottomAttachment, XmATTACH_FORM, NULL);
  mk_button_panel (buttonPanel);


}


/*
  menuBar = XmVaCreateSimpleMenuBar( frame_widg, "menuBar",
  // XmNleftAttachment, XmATTACH_FORM,
  XmNborderWidth, 1,     
  XmNorientation, XmVERTICAL,
  XmNwidth, 30, 
  XmNheight, 30,
  
  XmNx, 390,
  XmNy, 30,
  XmNtopAttachment, XmATTACH_WIDGET, 
  XmNtopWidget, appli_widg, 
  XmNbottomAttachment, XmATTACH_FORM, NULL);
*/
