module CONTEXT_LIB =
   process S_PACE_MAKER =
        { integer NUL_CODE, LIN_CODE; }
        ( ? event HE;
          ! event HES;
            event H_0;
            )
     (| (NEW_BOUND, HS_1) := PACE_MAKER{}( C_UP_DOWN, C_LIN_EXP, PI_0,  HS) 
      | HES := HS_1  ^+ TICK
      | (PI_0, H_0,ADR_COUNT, TICK, HS, C_LIN_EXP, C_UP_DOWN):= SCAN{NUL_CODE,LIN_CODE} (HE)
      | WIWRITE(ADR_COUNT when ^NEW_BOUND, NEW_BOUND)
      |)
      where 
      integer NEW_BOUND, ADR_COUNT, PI_0;
      event HS_1, HS, TICK;
      boolean C_LIN_EXP, C_UP_DOWN;
      process SCAN =
           { integer NUL_CODE, LIN_CODE; }
           ( ? event HE;
             ! integer PI_0;
               event H_0;
               integer ADR_COUNT;
               event TICK;
               event HS;
               boolean C_LIN_EXP;
               boolean C_UP_DOWN;
           )
         (| PERIOD_INPUT{NUL_CODE,LIN_CODE}
             | (| HINIT := H_0
                | MODE_INPUT{}
                |) where event HINIT; end
             | RESET_PANEL{}
             | (| HSTOP := STOP
                | WSTOP(HSTOP)
                |) where event HSTOP; end
             | INIT_PACE{}
             |)
         where 
         process MODE_INPUT =
              ( ? event HE;
                  event HINIT;
                ! event TICK;
                  boolean AUTO;
                  event HS;
                  event STOP;
              )
             (| (| (| C_SW_AUTO ^= HE
                      | C_SW_AUTO := RAUTO{}()
                      | NEXTAUTO ^= HINIT ^+ (when C_SW_AUTO)
                      | NEXTAUTO := not ZAUTO
                      | ZAUTO := NEXTAUTO$ init true
                      | AUTOMOD := NEXTAUTO cell HE init true
                      | HS := HE when AUTOMOD
                      |)
                   | AUTO := NEXTAUTO
                   |) where boolean NEXTAUTO; end/ C_SW_AUTO
                                             / ZAUTO
                | (| C_STOP ^= when (not AUTOMOD)
                   | C_STOP := RSTOP{}()
                   | STOP := when C_STOP
                   |)/ C_STOP
                | (| C_TICK ^= HE
                   | C_TICK := RTICK{}()
                   | TICK := when C_TICK
                   |)/ C_TICK
                |)
            where 
            process RAUTO =
                 ( ! boolean AUTO;
                 )
            
            ; 
            process RTICK =
                 ( ! boolean TICK;
                 )
            
            ; 
            process RSTOP =
                 ( ! boolean STOP;
                 )
            
            ; 
            boolean C_SW_AUTO, ZAUTO, AUTOMOD, C_STOP, C_TICK;
            end
         ; 
         process RESET_PANEL =
              ( ? boolean AUTO;
              )
         
         ; 
         process WSTOP =
              ( ? event DOWN;
              )
         
         ; 
         process INIT_PACE =
              ( ? event HE;
                ! event H_0;
                  integer PI_0;
                  integer ADR_COUNT;
              )
            (| CINIT := NCINIT$ init true
             | NCINIT := not HE
             | H_0 := when CINIT
             | DESCR ^= H_0
             | GET_PACE_RHYTHM{}()
             | ADR_COUNT := DESCR cell HE
             |)
            where 
            integer DESCR;
            boolean CINIT, NCINIT;
            process GET_PACE_RHYTHM =
                 ( ! integer DESCR;
                     integer PI_0;
                 )
               (| DESCR := GET_DESCR_PACEMAKER()
                | PI_0 := GET_PI_PACEMAKER()
                | PI_0 ^= DESCR
                |)
               where 
               process GET_DESCR_PACEMAKER =
                    ( ! integer DESCR;
                    )
               
               ; 
               process GET_PI_PACEMAKER =
                    ( ! integer DESCR;
                    )
               
               ; 
               end
            ; 
            end
         ; 
         event STOP;
         boolean AUTO;
         end
      ; 
      end
   ; 
   process PACE_MAKER =
        ( ? boolean C_UP_DOWN;
            boolean C_LIN_EXP;
            integer PI_0;
            event HE;
          ! integer NEW_BOUND;
            event HS;
        )
      (| HS := DYN_EVERY{0,1,1}(0 when HE, NEW_BOUND,HE)
       | SET_BOUND{}
       |)
      where 
      process SET_BOUND =
           ( ? boolean C_UP_DOWN;
               boolean C_LIN_EXP;
               integer PI_0;
             ! integer NEW_BOUND;
           )
        (| NEW_BOUND ^= C_LIN_EXP ^+ PI_0
         | NEW_BOUND := PI_0 default NEW_BOUND_2 default  NEW_BOUND_1 default OLD_BOUND
         | OLD_BOUND := NEW_BOUND$ init 1
         | NEW_BOUND_1 := EXPONENTIAL{}(C_UP_DOWN when (not C_LIN_EXP),OLD_BOUND when (not C_LIN_EXP))
         | NEW_BOUND_2 := LINEAR{}(C_UP_DOWN when C_LIN_EXP,OLD_BOUND when C_LIN_EXP)
         |)
        where 
          integer OLD_BOUND, NEW_BOUND_1, NEW_BOUND_2;
          integer NEW_EXP, NEW_LIN;
          process EXPONENTIAL =
            ( ? boolean C_UP_DOWN;
                integer OLD_BOUND;
              ! integer NEW_BOUND;
              )
            (| VD := (OLD_BOUND+OLD_BOUND) when (not C_UP_DOWN)
             | VU := (OLD_BOUND/2) when (OLD_BOUND>1) when C_UP_DOWN
             | NEW_BOUND := VU default (VD when (VD>0))
             |)
            where 
            integer VD, VU;
            end
         ; 
         process LINEAR =
              ( ? boolean C_UP_DOWN;
                  integer OLD_BOUND;
                ! integer NEW_BOUND;
              )
            (| DELTA := ((OLD_BOUND/16) when (OLD_BOUND>=16)) default (1 when (^OLD_BOUND))
             | VD := (OLD_BOUND+DELTA) when (not C_UP_DOWN)
             | VU := (OLD_BOUND-DELTA) when (OLD_BOUND>1) when C_UP_DOWN
             | NEW_BOUND := VU default (VD when (VD>0))
             |)
            where 
            integer DELTA, VD, VU;
            end
         ; 
      
         end
      ; 
      process DYN_EVERY =
           { integer PHY_0, PI_0, V_0; }
           ( ? integer PHY;
               integer PERIOD;
               event HE;
             ! event HS;
           )
         (| MAX1 := ((0 when (PERIOD<=1)) default (PERIOD-1)) cell HE init (PI_0-1)
          | MAX := MAX1 when HE
          | CPHY1 := ((0 when (PHY<0)) default PHY) cell HE init PHY_0
          | CPHY := CPHY1 when HE
          | ZV := V$ init V_0
          | V := (0 when (ZV>=MAX)) default (ZV+1)
          | HS := when (V=MAX % CPHY%)
          |)
         where 
         integer MAX1, MAX, CPHY1, CPHY, ZV, V;
         end
      ; 
      end
   ; 
   process PERIOD_INPUT =
        { integer NUL_CODE, LIN_CODE; }
        ( ? event HE;
            integer ADR_COUNT;
          ! boolean C_UP_DOWN;
            boolean C_LIN_EXP;
        )
      (| CODE_CHANGE := RCHANGE{}(ADR_COUNT when HE)
       | C_LIN_EXP := (CODE_CHANGE=LIN_CODE) when (CODE_CHANGE/=NUL_CODE)
       | C_UP_DOWN := RUPDOWN{}(ADR_COUNT when (^C_LIN_EXP))
       |)
      where 
      integer CODE_CHANGE;
      process RUPDOWN =
           ( ? integer ADRCOUNT;
             ! boolean UPDOWN;
           )
           spec (| ADRCOUNT ^= UPDOWN |)
      
      ; 
      process RCHANGE =
           ( ? integer ADRCOUNT;
             ! integer CODE;
           )
           spec (| ADRCOUNT ^= CODE |)
      
      ; 
      end
   ; 
   process WIWRITE =
        ( ? integer ADR_COUNT;
            integer V;
        )
        spec (| ADR_COUNT ^= V |)
   
   ; 
end %CONTEXT_LIB%; 
