package SignalLibraries.Java.graphical;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

/**
 * Buttons used for Signal simulation. This class keeps the state of the button, in order to know if it has been clicked
 * or not by the user. Once the value of the state is read, the state is reinitialized.
 */
public class SimuButton extends JButton {
	private static final long	serialVersionUID	= -2965171044624322002L;
	
	public boolean				state				= false;
	
	public SimuButton(String nam) {
		setText(nam);
		setActionCommand(nam);
	}
}

class defaultActionButton implements ActionListener {
	SimuButton	but;
	
	public defaultActionButton(SimuButton b) {
		but = b;
	}
	
	public void actionPerformed(ActionEvent event) {
		but.state = true;
	}
}
