
module AADL2SIGNAL=


process at_event = (? event i, h; ! o)
 pragmas
   Comment " o is produced, at h, iff i and h are simultaneous or after the previous out(or since the initial inbstant), there is at least an occurrence of i" 
 end pragmas

  (| in_occurs := (false when o) default i default in_occurred 
   | in_occurs ^= h ^+ i
   | in_occurred :=  in_occurs $1 init false
   | o := ( i default (true when in_occurred)) when h
   |)
  where 
    boolean in_occurs, in_occurred;
  end;


process shift = (? i; event h; ! o)
 pragmas
   Comment " o is produced, at h, iff i and h are simultaneous or after the previous out(or since the initial inbstant), there is at least an occurrence of i." 
           " The value of o is the value the most recent of i" 
 end pragmas
  (| m := i cell h 
   | o := m when at_event(^i, h)
   |)
  where
    m;
  end;
         
process at = (? i; event h; ! o)
 pragmas
   Comment " o is produced, at h, iff i and h are simultaneous or after the previous out(or since the initial inbstant), there is at least an occurrence of i." 
           " The value of o is the value the most recent of i" 
 end pragmas
  (| mm := i cell h 
   | o := mm when h
   |)
  where
    mm;
  end;
         
 
process at_next = (? i; event h; ! o)
 pragmas
   Comment " o is produced, at h, iff i and h are simultaneous or after the previous out(or since the initial inbstant), there is at least an occurrence of i." 
           " The value of o is the value the most recent of i" 
 end pragmas
  (| mmm := (i cell h) $1
   | o := mmm when h
   |)
  where
    mmm;
  end;
  

process delayed= (? i; event h, tick; ! o;)
  (| o := ( at(i,h) $1 ) cell tick |)
  ;

process immediate= (? i; event h; ! o;)
  (| o :=  i cell h |)
  ;

end;
        
